macroScript Svoe_KickHotBox_Modelling Category:"ASvoe" Tooltip:"KickHotBox_Modelling"


(if :: _SvDialogF != undefined do try(destroydialog _SvDialogF)catch()  -- Pri otkritii zakriv sozdannoe ranee
	
	if :: _Mssg != undefined do try(destroydialog _Mssg)catch()
	if :: _Mdfr != undefined do try(destroydialog _Mdfr)catch()
	if ::_HelpMsgQ != undefined do try(destroydialog _HelpMsgQ) catch()
	
	
	local TxtHelpQ1 = "KickHotBox_Modelling - 3ds MAX----\n ---Nikolay Antropov---\n \n  --Customize User Interface > Keyboard > Category Asvoe>KickHotBox_Modelling - Assign a hotkey --\n"
	local TxtHelpQ2 ="\n When Menu open - Press KeyBoard: \n `(Tilde) = AngleSnap Toggle\n A = CloseMenu \n Space = CloseMenu \n S = Convert EditablePoly \n E = MAX DELETE \n W = Lasso Selection Region \n Q = Rectangle Selection Region \n X = ResetXForm \n"
	local TxtHelpQ3 =" \n --MIDDLE BUTTON--\n \n MouseLeft = PreviewSelection switch (EditPoly) \n MouseLeft+Shift = SoftSlection (EditPoly) \n MouseLeft+Shift+Ctrl = IgnoreBackfacing"
	local TxtHelpQ4 =" \n MouseMiddle = Repeat_Last \n MouseMiddle+Shift = Constraints Face\n MouseMiddle+Ctrl = Constraints Edg\n MouseMiddle+Shift+Ctrl = Show_End_Result\n MouseRight = CloseMenu\n"
	local TxtHelpQ5 = " \n --Sli BUTTON--\n \n(Mouse Left, Middle, Right)= if select Edit poly then use Slice plane on x,y,z axis \n Ctrl+ (Mouse Left, Middle, Right) = if select EditPoly Make planar x,y,z \n "
	local TxtHelpQ6 = " \n --GROUP BUTTON--\n \n MouseLeft = Open/Clouse Group \n MouseLeft+Shift = Atach to group \n MouseLeft+Ctrl = Detach \n MouseLeft+Alt = Close \n MouseLeft+Ctrl+Shift = Ungroup \n MouseMiddle+Ctrl+Shift = DELETE! \n "
	local TxtHelpQ7 = " \n --MODIFIER BUTTON--\n \n MouseLeft = Modifiers menu \n MouseMiddle = Turbosmooth \n MouseMiddle+Ctrl = Symmetry\n MouseMiddle+Ctrl+Shift = ResetXForm \n MouseRight = EditPoly Modfr. \n MouseRight+Ctrl = Convert EditablePoly \n"
	local TxtHelpQ8 = " \n --------------\n Buttons --1--,--2--,--3--,--4--, Change it commands when select different type objects. Some commands with press Ctrl have options \n\n --1-- \n  EditPoly (Sub obj4) = Bevel / +Shift=QuikSlice \n"
	local TxtHelpQ9 = " \n  --2-- \n  EditPoly (Sub obj4) = Bridge / +Shift=CreateFace / +Ctrl=Bridge with Options \n"
	local TxtHelpQ10 = " \n  --3-- \n  EditPoly (Sub obj1) = Cut / +Shift=SlicePlane / +Ctrl=Connect \n EditPoly (Sub obj4) = Inset / +Shift=SlicePlane\n"
	local TxtHelpQ11 = " \n  --4-- \n  EditPoly (Sub obj4) = Extrude / +Shift=Hinge From Edge \n --------------\n"
	local TxtHelpQ12 = " \n --Buttons of levels (1.2.3.4.5) --\n (1) mouseMiddle = select \n (2) mouseMiddle = move \n (3) mouseMiddle = rotate\n  mouseMiddle+ Ctrl = Select and Manipulate \n (4) mouseMiddle = scale \n (5) mouseMiddle = normal align \n"
	
	
	
	Sl=modPanel.getCurrentObject()

	
----------------------------------------------------
	------------------Style -----------------------
----------------------------------------------------
		local _XStyle =  (dotNetObject "System.Drawing.Font" "Century Gothyc" 7 ((dotNetClass "System.Drawing.FontStyle").regular))
		local _FStyle =  (dotNetObject "System.Drawing.Font" "Century Gothyc" 6.4 ((dotNetClass "System.Drawing.FontStyle").regular))
		local _FColr = ((dotNetClass "System.Drawing.Color").fromArgb 20 60 80)
		local _BColr = ((dotNetClass "System.Drawing.Color").fromArgb 2 15 30)
		local _BrColr = ((dotNetClass "System.Drawing.Color").fromArgb 40 80 80)
		local _SlColr = ((dotNetClass "System.Drawing.Color").fromArgb 20 180 180)
		local _TxColr = ((dotNetClass "System.Drawing.Color").fromArgb 180 180 180)
		local _WxColr = ((dotNetClass "System.Drawing.Color").fromArgb 220 220 220)
		local _HlpColr = ((dotNetClass "System.Drawing.Color").fromArgb 40 80 90)
		local _XStyleHl = (dotNetObject "System.Drawing.Font" "Century Gothyc" 9 ((dotNetClass "System.Drawing.FontStyle").regular))
-----------------------------------------------------
-----------------------Local function ------------
-----------------------------------------------------
	
	
		fn Destr = (destroydialog _SvDialogF)
		fn Cl_edit = (classOf Sl  == Editable_Poly or (classOf Sl  == Edit_Poly))
		fn Cl_Spl = (classOf Sl == SplineShape or (classOf Sl  == Line))
		
			
								
		fn MssgQ1  = (							
							rollout _MssgQ1 "flat dialog"  height:20 width:110
							(
								dotNetControl MssgQ1Msg1 "System.Windows.Forms.Button" align:#center height:20 width:110 pos:[0, 0]
								
								timer tr interval: 0.1 active:True
								timer clock_Mssg "Clock" interval:1000 --tick once a second
								
								
								on _MssgQ1 open do (
									if ::_SvDialogF != undefined do try(destroydialog _SvDialogF)catch()
									if ::_Mdfr != undefined do try(destroydialog _Mdfr)catch()
									
								(mp = mouse.screenpos - [_MssgQ1.width-120, _MssgQ1.height-10] ---- Posiciya ot Mouse
							SetDialogPos _MssgQ1 mp)	
									
								MssgQ1Msg1.backColor = _FColr
								MssgQ1Msg1.FlatStyle =MssgQ1Msg1.FlatStyle.Flat
								MssgQ1Msg1.Font = _XStyle
								MssgQ1Msg1.Forecolor = _WxColr
								MssgQ1Msg1.FlatAppearance.BorderSize = 0
								MssgQ1Msg1.Text = "DELETE !!!" 
									)
								
								on clock_Mssg  tick do (destroydialog _MssgQ1) clock_MssgQ.Stop()
								on tr tick do (
												mp = mouse.screenpos - [_MssgQ1.width-120, _MssgQ1.height/2]
												SetDialogPos  _MssgQ1 mp)
								)
							createdialog _MssgQ1 style:#()  bgcolor: (color 2 50 60) 
							)	
		fn MssgQ2  = (							
							rollout _MssgQ2 "flat dialog"  height:20 width:110
							(
								dotNetControl MssgQ2Msg1 "System.Windows.Forms.Button" align:#center height:20 width:110 pos:[0, 0]
								
								timer tr interval: 0.1 active:True
								timer clock_Mssg "Clock" interval:1000 --tick once a second
								
								
								on _MssgQ2 open do (
									if ::_SvDialogF != undefined do try(destroydialog _SvDialogF)catch()
									if ::_Mdfr != undefined do try(destroydialog _Mdfr)catch()
									
								(mp = mouse.screenpos - [_MssgQ2.width-120, _MssgQ2.height-10] ---- Posiciya ot Mouse
							SetDialogPos _MssgQ2 mp)	
									
								MssgQ2Msg1.backColor = _FColr
								MssgQ2Msg1.FlatStyle =MssgQ2Msg1.FlatStyle.Flat
								MssgQ2Msg1.Font = _XStyle
								MssgQ2Msg1.Forecolor = _WxColr
								MssgQ2Msg1.FlatAppearance.BorderSize = 0
								MssgQ2Msg1.Text = "Ignor BackFacing" 
									)
								
								on clock_Mssg  tick do (destroydialog _MssgQ2) clock_MssgQ.Stop()
								on tr tick do (
												mp = mouse.screenpos - [_MssgQ2.width-120, _MssgQ2.height/2]
												SetDialogPos  _MssgQ2 mp)
								)
							createdialog _MssgQ2 style:#()  bgcolor: (color 2 50 60) 
							)	
							
			fn MssgQ3  = (							
							rollout _MssgQ3 "flat dialog"  height:20 width:110
							(
								dotNetControl MssgQ3Msg1 "System.Windows.Forms.Button" align:#center height:20 width:110 pos:[0, 0]
								
								timer tr interval: 0.1 active:True
								timer clock_Mssg "Clock" interval:1000 --tick once a second
								
								
								on _MssgQ3 open do (
									if ::_SvDialogF != undefined do try(destroydialog _SvDialogF)catch()
									if ::_Mdfr != undefined do try(destroydialog _Mdfr)catch()
									
								(mp = mouse.screenpos - [_MssgQ3.width-120, _MssgQ3.height-10] ---- Posiciya ot Mouse
							SetDialogPos _MssgQ3 mp)	
									
								MssgQ3Msg1.backColor = _FColr
								MssgQ3Msg1.FlatStyle =MssgQ3Msg1.FlatStyle.Flat
								MssgQ3Msg1.Font = _XStyle
								MssgQ3Msg1.Forecolor = _WxColr
								MssgQ3Msg1.FlatAppearance.BorderSize = 0
								MssgQ3Msg1.Text = "Soft Selection" 
									)
								
								on clock_Mssg  tick do (destroydialog _MssgQ3) clock_MssgQ.Stop()
								on tr tick do (
												mp = mouse.screenpos - [_MssgQ3.width-120, _MssgQ3.height/2]
												SetDialogPos  _MssgQ3 mp)
								)
							createdialog _MssgQ3 style:#()  bgcolor: (color 2 50 60) 
							)	
							
				fn MssgQ4  = (							
							rollout _MssgQ4 "flat dialog"  height:20 width:110
							(
								dotNetControl MssgQ4Msg1 "System.Windows.Forms.Button" align:#center height:20 width:110 pos:[0, 0]
								
								timer tr interval: 0.1 active:True
								timer clock_Mssg "Clock" interval:1000 --tick once a second
								
								
								on _MssgQ4 open do (
									if ::_SvDialogF != undefined do try(destroydialog _SvDialogF)catch()
									if ::_Mdfr != undefined do try(destroydialog _Mdfr)catch()
									
								(mp = mouse.screenpos - [_MssgQ4.width-120, _MssgQ4.height-10] ---- Posiciya ot Mouse
							SetDialogPos _MssgQ4 mp)	
									
								MssgQ4Msg1.backColor = _FColr
								MssgQ4Msg1.FlatStyle =MssgQ4Msg1.FlatStyle.Flat
								MssgQ4Msg1.Font = _XStyle
								MssgQ4Msg1.Forecolor = _WxColr
								MssgQ4Msg1.FlatAppearance.BorderSize = 0
								MssgQ4Msg1.Text = "Show_End_Result" 
									)
								
								on clock_Mssg  tick do (destroydialog _MssgQ4) clock_MssgQ.Stop()
								on tr tick do (
												mp = mouse.screenpos - [_MssgQ4.width-120, _MssgQ4.height/2]
												SetDialogPos  _MssgQ4 mp)
								)
							createdialog _MssgQ4 style:#()  bgcolor: (color 2 50 60) 
							)
							
				fn MssgQ5  = (							
							rollout _MssgQ5 "flat dialog"  height:20 width:110
							(
								dotNetControl MssgQ5Msg1 "System.Windows.Forms.Button" align:#center height:20 width:110 pos:[0, 0]
								
								timer tr interval: 0.1 active:True
								timer clock_Mssg "Clock" interval:1000 --tick once a second
								
								
								on _MssgQ5 open do (
									if ::_SvDialogF != undefined do try(destroydialog _SvDialogF)catch()
									if ::_Mdfr != undefined do try(destroydialog _Mdfr)catch()
									
								(mp = mouse.screenpos - [_MssgQ5.width-120, _MssgQ5.height-10] ---- Posiciya ot Mouse
							SetDialogPos _MssgQ5 mp)	
									
								MssgQ5Msg1.backColor = _FColr
								MssgQ5Msg1.FlatStyle =MssgQ5Msg1.FlatStyle.Flat
								MssgQ5Msg1.Font = _XStyle
								MssgQ5Msg1.Forecolor = _WxColr
								MssgQ5Msg1.FlatAppearance.BorderSize = 0
								MssgQ5Msg1.Text ="Constraints Face on/off" 
									)
								
								on clock_Mssg  tick do (destroydialog _MssgQ5) clock_MssgQ.Stop()
								on tr tick do (
												mp = mouse.screenpos - [_MssgQ5.width-120, _MssgQ5.height/2]
												SetDialogPos  _MssgQ5 mp)
								)
							createdialog _MssgQ5 style:#()  bgcolor: (color 2 50 60) 
							)
							
				fn MssgQ6  = (							
							rollout _MssgQ6 "flat dialog"  height:20 width:110
							(
								dotNetControl MssgQ6Msg1 "System.Windows.Forms.Button" align:#center height:20 width:110 pos:[0, 0]
								
								timer tr interval: 0.1 active:True
								timer clock_Mssg "Clock" interval:1000 --tick once a second
								
								
								on _MssgQ6 open do (
									if ::_SvDialogF != undefined do try(destroydialog _SvDialogF)catch()
									if ::_Mdfr != undefined do try(destroydialog _Mdfr)catch()
									
								(mp = mouse.screenpos - [_MssgQ6.width-120, _MssgQ6.height-10] ---- Posiciya ot Mouse
							SetDialogPos _MssgQ6 mp)	
									
								MssgQ6Msg1.backColor = _FColr
								MssgQ6Msg1.FlatStyle =MssgQ6Msg1.FlatStyle.Flat
								MssgQ6Msg1.Font = _XStyle
								MssgQ6Msg1.Forecolor = _WxColr
								MssgQ6Msg1.FlatAppearance.BorderSize = 0
								MssgQ6Msg1.Text = "Constraints Edg on/off" 
									)
								
								on clock_Mssg  tick do (destroydialog _MssgQ6) clock_MssgQ.Stop()
								on tr tick do (
												mp = mouse.screenpos - [_MssgQ6.width-120, _MssgQ6.height/2]
												SetDialogPos  _MssgQ6 mp)
								)
							createdialog _MssgQ6 style:#()  bgcolor: (color 2 50 60) 
							)
							
				fn MssgQ7  = (							
							rollout _MssgQ7 "flat dialog"  height:20 width:110
							(
								dotNetControl MssgQ7Msg1 "System.Windows.Forms.Button" align:#center height:20 width:110 pos:[0, 0]
								
								timer tr interval: 0.1 active:True
								timer clock_Mssg "Clock" interval:1000 --tick once a second
								
								
								on _MssgQ7 open do (
									if ::_SvDialogF != undefined do try(destroydialog _SvDialogF)catch()
									if ::_Mdfr != undefined do try(destroydialog _Mdfr)catch()
									
								(mp = mouse.screenpos - [_MssgQ7.width-120, _MssgQ7.height-10] ---- Posiciya ot Mouse
							SetDialogPos _MssgQ7 mp)	
									
								MssgQ7Msg1.backColor = _FColr
								MssgQ7Msg1.FlatStyle =MssgQ7Msg1.FlatStyle.Flat
								MssgQ7Msg1.Font = _XStyle
								MssgQ7Msg1.Forecolor = _WxColr
								MssgQ7Msg1.FlatAppearance.BorderSize = 0
								MssgQ7Msg1.Text = "Reset Xform"
									)
								
								on clock_Mssg  tick do (destroydialog _MssgQ7) clock_MssgQ.Stop()
								on tr tick do (
												mp = mouse.screenpos - [_MssgQ7.width-120, _MssgQ7.height/2]
												SetDialogPos  _MssgQ7 mp)
								)
							createdialog _MssgQ7 style:#()  bgcolor: (color 2 50 60) 
							)
							
				fn MssgQ8  = (							
							rollout _MssgQ8 "flat dialog"  height:20 width:110
							(
								dotNetControl MssgQ8Msg1 "System.Windows.Forms.Button" align:#center height:20 width:110 pos:[0, 0]
								
								timer tr interval: 0.1 active:True
								timer clock_Mssg "Clock" interval:1000 --tick once a second
								
								
								on _MssgQ8 open do (
									if ::_SvDialogF != undefined do try(destroydialog _SvDialogF)catch()
									if ::_Mdfr != undefined do try(destroydialog _Mdfr)catch()
									
								(mp = mouse.screenpos - [_MssgQ8.width-120, _MssgQ8.height-10] ---- Posiciya ot Mouse
							SetDialogPos _MssgQ8 mp)	
									
								MssgQ8Msg1.backColor = _FColr
								MssgQ8Msg1.FlatStyle =MssgQ8Msg1.FlatStyle.Flat
								MssgQ8Msg1.Font = _XStyle
								MssgQ8Msg1.Forecolor = _WxColr
								MssgQ8Msg1.FlatAppearance.BorderSize = 0
								MssgQ8Msg1.Text = "Convert to EditPol"
									)
								
								on clock_Mssg  tick do (destroydialog _MssgQ8) clock_MssgQ.Stop()
								on tr tick do (
												mp = mouse.screenpos - [_MssgQ8.width-120, _MssgQ8.height/2]
												SetDialogPos  _MssgQ8 mp)
								)
							createdialog _MssgQ8 style:#()  bgcolor: (color 2 50 60) 
							)
							
							
							
							
							
fn _HelpMsgQ  = (
	
							rollout _HelpMsgQ  "flat dialog"  height:630 width:600
							(
								dotNetControl HelpMsgQ1 "System.Windows.Forms.Button" align:#center height:630 width:300 pos:[0, 0]
								dotNetControl HelpMsgQ2 "System.Windows.Forms.Button" align:#center height:630 width:300 pos:[300, 0]
								
																
								on _HelpMsgQ  open do (if ::_SvDialogF != undefined do try(destroydialog _SvDialogF)catch()
															if ::_Mssg != undefined do try(destroydialog _Mssg)catch()
															--if ::_Mssg != undefined do try(destroydialog _HelpMsgQ)catch()
									
								(mp = mouse.screenpos - [_HelpMsgQ .width-90, _HelpMsgQ .height-200] ---- Posiciya ot Mouse
							SetDialogPos _HelpMsgQ  mp)
									
								HelpMsgQ1.backColor = _FColr
								HelpMsgQ1.FlatStyle =HelpMsgQ1.FlatStyle.Flat
								HelpMsgQ1.Font = _XStyleHl
								HelpMsgQ1.TextAlign = HelpMsgQ1.TextAlign.MiddleLeft
								HelpMsgQ1.Forecolor = _WxColr
								HelpMsgQ1.FlatAppearance.BorderSize = 0
								HelpMsgQ1.Text = TxtHelpQ1+TxtHelpQ2+TxtHelpQ3+TxtHelpQ4+TxtHelpQ5+TxtHelpQ6
								
								HelpMsgQ2.backColor = _FColr
								HelpMsgQ2.FlatStyle =HelpMsgQ2.FlatStyle.Flat
								HelpMsgQ2.Font = _XStyleHl
								HelpMsgQ2.TextAlign = HelpMsgQ1.TextAlign.MiddleLeft
								HelpMsgQ2.Forecolor = _WxColr
								HelpMsgQ2.FlatAppearance.BorderSize = 0
								HelpMsgQ2.Text = TxtHelpQ7+TxtHelpQ8+TxtHelpQ9+TxtHelpQ10+TxtHelpQ11+TxtHelpQ12

									)
									
							on HelpMsgQ1 mousedown evnt do (destroydialog _HelpMsgQ)
							on HelpMsgQ2 mousedown evnt do (destroydialog _HelpMsgQ)
										
							
											

								)
							createdialog _HelpMsgQ  style:#()  bgcolor: (color 2 50 60) 
							)
							
----------------------------------------------
	fn _Mdfr  = (
	
							rollout _Mdfr "flat dialog"  height:175 width:270
							(
								dotNetControl Mdf1 "System.Windows.Forms.Button" align:#center height:25 width:90 pos:[0, 0]
								dotNetControl Mdf2 "System.Windows.Forms.Button" align:#center height:25 width:90 pos:[0, 25]
								dotNetControl Mdf3 "System.Windows.Forms.Button" align:#center height:25 width:90 pos:[0, 50]
								dotNetControl Mdf4 "System.Windows.Forms.Button" align:#center height:25 width:90 pos:[0, 75]
								dotNetControl Mdf5 "System.Windows.Forms.Button" align:#center height:25 width:90 pos:[0, 100]
								dotNetControl Mdf6 "System.Windows.Forms.Button" align:#center height:25 width:90 pos:[0, 125]
								dotNetControl Mdf_6 "System.Windows.Forms.Button" align:#center height:25 width:90 pos:[0, 150]
								
								dotNetControl Mdf7 "System.Windows.Forms.Button" align:#center height:25 width:90 pos:[90, 0]
								dotNetControl Mdf8 "System.Windows.Forms.Button" align:#center height:25 width:90 pos:[90, 25]
								dotNetControl Mdf9 "System.Windows.Forms.Button" align:#center height:25 width:90 pos:[90, 50]
								dotNetControl Mdf10 "System.Windows.Forms.Button" align:#center height:25 width:90 pos:[90, 75]
								dotNetControl Mdf11 "System.Windows.Forms.Button" align:#center height:25 width:90 pos:[90, 100]
								dotNetControl Mdf12 "System.Windows.Forms.Button" align:#center height:25 width:90 pos:[90, 125]
								dotNetControl Mdf_12 "System.Windows.Forms.Button" align:#center height:25 width:90 pos:[90, 150]
								
								dotNetControl Mdf13 "System.Windows.Forms.Button" align:#center height:25 width:90 pos:[180, 0]
								dotNetControl Mdf14 "System.Windows.Forms.Button" align:#center height:25 width:90 pos:[180, 25]
								dotNetControl Mdf15 "System.Windows.Forms.Button" align:#center height:25 width:90 pos:[180, 50]
								dotNetControl Mdf16 "System.Windows.Forms.Button" align:#center height:25 width:90 pos:[180, 75]
								dotNetControl Mdf17 "System.Windows.Forms.Button" align:#center height:25 width:90 pos:[180, 100]
								dotNetControl Mdf18 "System.Windows.Forms.Button" align:#center height:25 width:90 pos:[180, 125]
								dotNetControl Mdf_18 "System.Windows.Forms.Button" align:#center height:25 width:90 pos:[180, 150]
								
								timer mclock "Clock" interval:4000 --tick once a second
								
									-----
			
			-----
								
								on _Mdfr open do (if ::_SvDialogF != undefined do try(destroydialog _SvDialogF)catch()
															if ::_Mssg != undefined do try(destroydialog _Mssg)catch()
									
								(mp = mouse.screenpos - [_Mdfr.width-130, _Mdfr.height-70] ---- Posiciya ot Mouse
							SetDialogPos _Mdfr mp)
							
							Mdf1.refresh()  --- bez etogo ne rabotaet knopki tipo goryachih klavish
							Mdf1.focus()
							max modify mode
									
								Mdf1.backColor = _FColr
								Mdf1.FlatStyle =Mdf1.FlatStyle.Flat
								Mdf1.Font = _XStyle
								Mdf1.Forecolor = _WxColr
								Mdf1.FlatAppearance.BorderSize = 0
								Mdf1.Text = "UVWmap" 
								
								Mdf2.backColor = _FColr
								Mdf2.FlatStyle =Mdf1.FlatStyle.Flat
								Mdf2.Font = _XStyle
								Mdf2.Forecolor = _WxColr
								Mdf2.FlatAppearance.BorderSize = 0
								Mdf2.Text = "Unwarp map" 
							
								Mdf3.backColor = _BColr
								Mdf3.FlatStyle =Mdf1.FlatStyle.Flat
								Mdf3.Font = _XStyle
								Mdf3.Forecolor = _WxColr
								Mdf3.FlatAppearance.BorderSize = 0
								Mdf3.Text = "FFD 2x2"
							
								Mdf4.backColor = _BColr
								Mdf4.FlatStyle =Mdf1.FlatStyle.Flat
								Mdf4.Font = _XStyle
								Mdf4.Forecolor = _WxColr
								Mdf4.FlatAppearance.BorderSize = 0
								Mdf4.Text = "FFD 3x3" 
							
								Mdf5.backColor = _BColr
								Mdf5.FlatStyle =Mdf1.FlatStyle.Flat
								Mdf5.Font = _XStyle
								Mdf5.Forecolor = _WxColr
								Mdf5.FlatAppearance.BorderSize = 0
								Mdf5.Text = "FFD box"
							
								Mdf6.backColor = _BColr
								Mdf6.FlatStyle =Mdf1.FlatStyle.Flat
								Mdf6.Font = _XStyle
								Mdf6.Forecolor = _WxColr
								Mdf6.FlatAppearance.BorderSize = 0
								Mdf6.Text = "FFD Cyl"
								
								Mdf_6.backColor = _FColr
								Mdf_6.FlatStyle =Mdf1.FlatStyle.Flat
								Mdf_6.Font = _XStyle
								Mdf_6.Forecolor = _WxColr
								Mdf_6.FlatAppearance.BorderSize = 0
								Mdf_6.Text = "Noise"
							
								Mdf7.backColor = _BColr
								Mdf7.FlatStyle =Mdf1.FlatStyle.Flat
								Mdf7.Font = _XStyle
								Mdf7.Forecolor = _WxColr
								Mdf7.FlatAppearance.BorderSize = 0
								Mdf7.Text = "Turbosmoth"
							
								Mdf8.backColor = _FColr
								Mdf8.FlatStyle =Mdf1.FlatStyle.Flat
								Mdf8.Font = _XStyle
								Mdf8.Forecolor = _WxColr
								Mdf8.FlatAppearance.BorderSize = 0
								Mdf8.Text = "Shell"
							
								Mdf9.backColor = _BColr
								Mdf9.FlatStyle =Mdf1.FlatStyle.Flat
								Mdf9.Font = _XStyle
								Mdf9.Forecolor = _WxColr
								Mdf9.FlatAppearance.BorderSize = 0
								Mdf9.Text = "Symmetry"
								
								Mdf10.backColor = _BrColr
								Mdf10.FlatStyle =Mdf1.FlatStyle.Flat
								Mdf10.Font = _XStyle
								Mdf10.Forecolor = _WxColr
								Mdf10.FlatAppearance.BorderSize = 0
								Mdf10.Text = "EditPoly"
								
								
								Mdf11.backColor = _BrColr
								Mdf11.FlatStyle =Mdf1.FlatStyle.Flat
								Mdf11.Font = _XStyle
								Mdf11.Forecolor = _WxColr
								Mdf11.FlatAppearance.BorderSize = 0
								Mdf11.Text = "ConvEditPoly"
								
								Mdf12.backColor = _BrColr
								Mdf12.FlatStyle =Mdf1.FlatStyle.Flat
								Mdf12.Font = _XStyle
								Mdf12.Forecolor = _WxColr
								Mdf12.FlatAppearance.BorderSize = 0
								Mdf12.Text = "ResetXform"
								
								Mdf_12.backColor = _FColr
								Mdf_12.FlatStyle =Mdf1.FlatStyle.Flat
								Mdf_12.Font = _XStyle
								Mdf_12.Forecolor = _WxColr
								Mdf_12.FlatAppearance.BorderSize = 0
								Mdf_12.Text = "Morpher"
								
								Mdf13.backColor = _FColr
								Mdf13.FlatStyle =Mdf1.FlatStyle.Flat
								Mdf13.Font = _XStyle
								Mdf13.Forecolor = _WxColr
								Mdf13.FlatAppearance.BorderSize = 0
								Mdf13.Text = "Extrude"
								
								Mdf14.backColor = _BColr
								Mdf14.FlatStyle =Mdf1.FlatStyle.Flat
								Mdf14.Font = _XStyle
								Mdf14.Forecolor = _WxColr
								Mdf14.FlatAppearance.BorderSize = 0
								Mdf14.Text = "Sweep"
								
								Mdf15.backColor = _FColr
								Mdf15.FlatStyle =Mdf1.FlatStyle.Flat
								Mdf15.Font = _XStyle
								Mdf15.Forecolor = _WxColr
								Mdf15.FlatAppearance.BorderSize = 0
								Mdf15.Text = "Loft"
								
								Mdf16.backColor = _BrColr
								Mdf16.FlatStyle =Mdf1.FlatStyle.Flat
								Mdf16.Font = _XStyle
								Mdf16.Forecolor = _WxColr
								Mdf16.FlatAppearance.BorderSize = 0
								Mdf16.Text = "Conv editSpline"
								
								Mdf17.backColor = _FColr
								Mdf17.FlatStyle =Mdf1.FlatStyle.Flat
								Mdf17.Font = _XStyle
								Mdf17.Forecolor = _WxColr
								Mdf17.FlatAppearance.BorderSize = 0
								Mdf17.Text = "Lathe"
								
								Mdf18.backColor = _BColr
								Mdf18.FlatStyle =Mdf1.FlatStyle.Flat
								Mdf18.Font = _XStyle
								Mdf18.Forecolor = _WxColr
								Mdf18.FlatAppearance.BorderSize = 0
								Mdf18.Text = "Slice"
								
								Mdf_18.backColor = _FColr
								Mdf_18.FlatStyle =Mdf1.FlatStyle.Flat
								Mdf_18.Font = _XStyle
								Mdf_18.Forecolor = _WxColr
								Mdf_18.FlatAppearance.BorderSize = 0
								Mdf_18.Text = "Cap_Holes"
							
									)
								
			on Mdf1 keydown evnt do (
										if evnt.keycode == evnt.keycode.space do (destroydialog _Mdfr)
										if evnt.keycode == evnt.keycode.a do (destroydialog _Mdfr)
										)
										
										
			on Mdf1 mousedown arg do (
										case arg.Button of
														(
									(arg.Button.Left): 		((macros.run "Modifiers" "Uvwmap" )
																		destroydialog _Mdfr)
									(arg.Button.Middle):  	((macros.run "Modifiers" "Uvwmap" )
																		$.modifiers[#UVW_Map].maptype = 4
																		destroydialog _Mdfr)	
									(arg.Button.Right): 		(destroydialog _Mdfr)	
														)
													)

														
														
			on Mdf2 mousedown arg do	(
										case arg.Button of
														(
									(arg.Button.Left): 		((macros.run "Modifiers" "Unwrap_UVW")
																		destroydialog _Mdfr)
									(arg.Button.Middle):  	()	
									(arg.Button.Right): 		(destroydialog _Mdfr)	
														)
													)

			on Mdf3 mousedown arg do	(
										case arg.Button of
														(
									(arg.Button.Left): 		((macros.run "Modifiers" "FFD_2x2x2")
																		destroydialog _Mdfr)
									(arg.Button.Middle):  	()	
									(arg.Button.Right): 		(destroydialog _Mdfr)	
														)
													)
													
			on Mdf4 mousedown arg do	(
										case arg.Button of
														(
									(arg.Button.Left): 		((macros.run "Modifiers" "FFD_3x3x3") --(modPanel.addModToSelection (FFD_3x3x3 ()) ui:on)
																		destroydialog _Mdfr)
									(arg.Button.Middle):  	()	
									(arg.Button.Right): 		(destroydialog _Mdfr)	
														)
													)

			on Mdf5 mousedown arg do	(
										case arg.Button of
														(
									(arg.Button.Left): 		((macros.run "Modifiers" "FFDBox")
																		destroydialog _Mdfr)
									(arg.Button.Middle):  	()	
									(arg.Button.Right): 		(destroydialog _Mdfr)	
														)
													)
													
			on Mdf6 mousedown arg do	(
										case arg.Button of
														(
									(arg.Button.Left): 		((macros.run "Modifiers" "FFDCyl")
																		destroydialog _Mdfr)
									(arg.Button.Middle):  	()	
									(arg.Button.Right): 		(destroydialog _Mdfr)	
														)
													)
													
			on Mdf_6 mousedown arg do	(
										case arg.Button of
														(
									(arg.Button.Left): 		((macros.run "Modifiers" "Noise")
																		destroydialog _Mdfr)
									(arg.Button.Middle):  	()	
									(arg.Button.Right): 		(destroydialog _Mdfr)	
														)
													)
													
			on Mdf7 mousedown arg do	(
										case arg.Button of
														(
									(arg.Button.Left): 		((macros.run "Modifiers" "TurboSmoothMod" )
																		destroydialog _Mdfr)
									(arg.Button.Middle):  	((macros.run "Modifiers" "TurboSmoothMod" )
																		$.modifiers[#TurboSmooth].sepBySmGroups = on
																		destroydialog _Mdfr)	
									(arg.Button.Right): 		(destroydialog _Mdfr)	
														)
													)
													
			on Mdf8 mousedown arg do	(
										case arg.Button of
														(
									(arg.Button.Left): 		((macros.run "Modifiers" "Shell" )
																		destroydialog _Mdfr)
									(arg.Button.Middle):  	()	
									(arg.Button.Right): 		(destroydialog _Mdfr)	
														)
													)
													
			on Mdf9 mousedown arg do	(
										case arg.Button of
														(
									(arg.Button.Left): 		((macros.run "Modifiers" "Symmetry" )
																		destroydialog _Mdfr)
									(arg.Button.Middle):  	()	
									(arg.Button.Right): 		(destroydialog _Mdfr)	
														)
													)
													
			on Mdf10 mousedown arg do	(
										case arg.Button of
														(
									(arg.Button.Left): 		((macros.run "Modifiers" "EditPolyMod") 
																		destroydialog _Mdfr)
									(arg.Button.Middle):  	()	
									(arg.Button.Right): 		(destroydialog _Mdfr)	
														)
													)
													
			on Mdf11 mousedown arg do	(
										case arg.Button of
														(
									(arg.Button.Left): 		((macros.run "Modifier Stack" "Convert_to_Poly")
																		destroydialog _Mdfr)
									(arg.Button.Middle):  	()	
									(arg.Button.Right): 		(destroydialog _Mdfr)	
														)
													)
													
			on Mdf12 mousedown arg do	(
										case arg.Button of
														(
									(arg.Button.Left): 		((macros.run "PolyTools" "ResetXForm")
																		destroydialog _Mdfr)
									(arg.Button.Middle):  	()	
									(arg.Button.Right): 		(destroydialog _Mdfr)	
														)
													)
													
			on Mdf_12 mousedown arg do	(
										case arg.Button of
														(
									(arg.Button.Left): 		((macros.run "Modifiers" "Morpher")
																		destroydialog _Mdfr)
									(arg.Button.Middle):  	()	
									(arg.Button.Right): 		(destroydialog _Mdfr)	
														)
													)

			on Mdf13 mousedown arg do	(
										case arg.Button of
														(
									(arg.Button.Left): 		(if  (classOf $ ==SplineShape or classOf $==Line) then (macros.run "Modifiers" "Extrude")
										 else if (classOf $== Arc or classOf $ == Helix or classOf $ == Star 	or classOf $ == Circle or classOf $ ==  Egg) then (macros.run "Modifiers" "Extrude")
										else if (classOf $ ==Rectangle or classOf $== Text or classOf $ == Donut or classOf $==NGon or classOf $ ==Ellipse) then (macros.run "Modifiers" "Extrude")
										else if  (classOf $ == Section or classOf $ == Angle or classOf $==Channel or classOf $==Tee) then (macros.run "Modifiers" "Extrude")
										else if  (classOf $==WalledRectangle or classOf $== WideFlange) then (macros.run "Modifiers" "Extrude")
																		destroydialog _Mdfr)
									(arg.Button.Middle):  	()	
									(arg.Button.Right): 		(destroydialog _Mdfr)	
														)
													)
													
			on Mdf14 mousedown arg do	(
										case arg.Button of
														(
									(arg.Button.Left): 		
															(if  (classOf $ ==SplineShape or classOf $==Line) then (macros.run "Modifiers" "SweepMod")
										 else if (classOf $== Arc or classOf $ == Helix or classOf $ == Star 	or classOf $ == Circle or classOf $ ==  Egg) then (macros.run "Modifiers" "SweepMod")
										else if (classOf $ ==Rectangle or classOf $== Text or classOf $ == Donut or classOf $==NGon or classOf $ ==Ellipse) then (macros.run "Modifiers" "SweepMod")
										else if  (classOf $ == Section or classOf $ == Angle or classOf $==Channel or classOf $==Tee) then (macros.run "Modifiers" "SweepMod")
										else if  (classOf $==WalledRectangle or classOf $== WideFlange) then (macros.run "Modifiers" "SweepMod")
																															destroydialog _Mdfr)
																		
									(arg.Button.Middle):  	()	
									(arg.Button.Right): 		(destroydialog _Mdfr)	
														)
													)
			on Mdf15 mousedown arg do	(
										case arg.Button of
														(
									(arg.Button.Left): 		((macros.run "Objects Compounds" "Loft")
																		destroydialog _Mdfr)
									(arg.Button.Middle):  	()	
									(arg.Button.Right): 		(destroydialog _Mdfr)	
														)
													)
													
			on Mdf16 mousedown arg do	(
										case arg.Button of
														(
									(arg.Button.Left): 		((macros.run "Modifier Stack" "Convert_to_Spline")
																		destroydialog _Mdfr)
									(arg.Button.Middle):  	()	
									(arg.Button.Right): 		(destroydialog _Mdfr)	
														)
													)
													
			on Mdf17 mousedown arg do	(
										case arg.Button of
														(
									(arg.Button.Left): 		
															(if  (classOf $ ==SplineShape or classOf $==Line) then (macros.run "Modifiers" "Lathe")
										 else if (classOf $== Arc or classOf $ == Helix or classOf $ == Star 	or classOf $ == Circle or classOf $ ==  Egg) then (macros.run "Modifiers" "Lathe")
										else if (classOf $ ==Rectangle or classOf $== Text or classOf $ == Donut or classOf $==NGon or classOf $ ==Ellipse) then (macros.run "Modifiers" "Lathe")
										else if  (classOf $ == Section or classOf $ == Angle or classOf $==Channel or classOf $==Tee) then (macros.run "Modifiers" "Lathe")
										else if  (classOf $==WalledRectangle or classOf $== WideFlange) then (macros.run "Modifiers" "Lathe")
																	destroydialog _Mdfr)
									(arg.Button.Middle):  	()	
									(arg.Button.Right): 		(destroydialog _Mdfr)	
														)
													)
													
			on Mdf18 mousedown arg do	(
										case arg.Button of
														(
									(arg.Button.Left): 		((macros.run "Modifiers" "Slice" )
																		destroydialog _Mdfr)
									(arg.Button.Middle):  	()	
									(arg.Button.Right): 		(destroydialog _Mdfr)	
														)
													)
													
			on Mdf_18 mousedown arg do	(
										case arg.Button of
														(
									(arg.Button.Left): 		((macros.run "Modifiers" "Cap_Holes")
																		destroydialog _Mdfr)
									(arg.Button.Middle):  	()	
									(arg.Button.Right): 		(destroydialog _Mdfr)	
														)
													)
										
											
										
								on mclock  tick do (destroydialog _Mdfr)
											

								
								)
							createdialog _Mdfr style:#()  bgcolor: (color 2 50 60) 
							)	



	
	----------------------------------------------------------------------
		---------------------buttons apper----------------------------
	--------------------------------------------------------------------
	
	local _LvlColr1 = (
							if selection.count == 0 and subobjectLevel == 0 or subobjectlevel == undefined then (_BColr)
							else if  numSubObjectLevels < 1  and subobjectlevel != 1 then (_BColr) -- big then Sl ----
							else if   numSubObjectLevels < 2  and subobjectlevel != 1 then (_FColr) -- small of lagre then Sl ---
							else if  subobjectlevel == 1 then (_SlColr)  -- Color Sl lvl
							else (_FColr)
									)
	local _LvlColr2 = (if selection.count == 0 and subobjectLevel == 0 or subobjectlevel == undefined then (_BColr)
							else if  numSubObjectLevels < 2  and subobjectlevel != 2 then (_BColr) -- big then Sl ----
							else if   numSubObjectLevels < 3  and subobjectlevel != 2 then (_FColr) -- small of lagre then Sl ---
							else if  subobjectlevel == 2 then (_SlColr)  -- Color Sl lvl
							else (_FColr)
							)
	local _LvlColr3 = (if selection.count == 0 and subobjectLevel == 0 or subobjectlevel == undefined then (_BColr)
							else if  numSubObjectLevels < 3  and subobjectlevel != 3 then (_BColr) -- big then Sl ----
							else if   numSubObjectLevels < 4  and subobjectlevel != 3 then (_FColr) -- small of lagre then Sl ---
							else if  subobjectlevel == 3 then (_SlColr)  -- Color Sl lvl
							else (_FColr)
							)
	local _LvlColr4 = ( if selection.count == 0 and subobjectLevel == 0 or subobjectlevel == undefined then (_BColr)
							else if  numSubObjectLevels < 4  and subobjectlevel != 4 then (_BColr) -- big then Sl ----
							else if   numSubObjectLevels < 5  and subobjectlevel != 4 then (_FColr) -- small of lagre then Sl ---
							else if  subobjectlevel == 4 then (_SlColr)  -- Color Sl lvl
							else (_FColr)
							)
	local _LvlColr5 = ( if selection.count == 0 and subobjectLevel == 0 or subobjectlevel == undefined then (_BColr)
								else if  numSubObjectLevels < 5  and subobjectlevel != 5 then (_BColr) -- big then Sl ----
								--else if   numSubObjectLevels < 2  and subobjectlevel != 5 then (_FColr) -- small of lagre then Sl ---
								else if  subobjectlevel == 5 then (_SlColr)  -- Color Sl lvl
								else (_FColr)
							)
				
	
	local _1Text = (
				
		-- if selection.count == 0 and subobjectLevel == 0 or subobjectlevel == undefined then ("---")
						 if subobjectLevel== 0 and Cl_edit() then ("Atach")
						else if  subobjectLevel== 1 and Cl_edit() then ("Targ Weld")
						else if  subobjectLevel== 2 and Cl_edit() then ("Connect")
						else if subobjectLevel== 3 and Cl_edit() then ("Connect")
						else if  subobjectLevel== 4 and Cl_edit() then ("BEVEL \nqsl")
						else if  subobjectLevel== 5 and Cl_edit() then ("Detach")
							
						else if   subobjectLevel== 0 and Cl_Spl()  then ("Atach")
						else if  subobjectLevel== 1 and Cl_Spl() then ("Chamfer")
						else if  subobjectLevel== 2 and Cl_Spl() then ("Refine")
						else if  subobjectLevel== 3 and Cl_Spl() then ("Outline")
							
						else if selection.count == 1 and subobjectLevel== 0 and (classOf Sl == Turbosmooth ) then ("Smooth Group")
		
						else if selection.count == 1 and subobjectLevel== 0 and (classOf Sl == Uvwmap ) then ("Mapping swither") 
						else if selection.count == 1 and subobjectLevel== 1 and (classOf Sl == Uvwmap ) then ("Swith Axis") 
		
						else if selection.count == 1 and subobjectLevel== 0 and (classOf Sl == Unwrap_UVW) then ("Open UV Editor") 
						else if selection.count == 1 and subobjectLevel== 1 and (classOf Sl == Unwrap_UVW) then ("set Pelt Point")
						else if selection.count == 1 and subobjectLevel== 2 and (classOf Sl == Unwrap_UVW) then ("Edit Seams")
						else if selection.count == 1 and subobjectLevel== 3 and (classOf Sl == Unwrap_UVW) then ("PlgnSel To Seams")
						
						else if selection.count == 1 and subobjectLevel== 0 and (classOf Sl == Sweep) then ("Slectn type") 
						
												
						else if selection.count == 1 and subobjectLevel== 0 and (classOf Sl == Turbosmooth) then ("by smooth group") 
							else ("---1---")
							)		
							
	local _2Text = (
						if subobjectLevel== 0 and (Cl_edit()) then ("Quick Slice")
						else if subobjectLevel== 1 and (Cl_edit()) then ("Weld")
						else if subobjectLevel== 2 and (Cl_edit()) then ("Bridje")
						else if subobjectLevel== 3 and (Cl_edit()) then ("Bridje")
						else if subobjectLevel== 4 and (Cl_edit()) then ("BRIDGE\ncreatFace")
						else if subobjectLevel== 5 and (Cl_edit()) then ("Create Face")
							
						else if subobjectLevel== 0 and Cl_Spl() then ("Create Line")
						else if subobjectLevel== 1 and Cl_Spl() then ("Fillet")
						else if subobjectLevel== 2 and Cl_Spl() then ("Divide")
						else if subobjectLevel== 3 and Cl_Spl() then ("Close Spline")
							
						else if selection.count == 1 and subobjectLevel== 0 and (classOf Sl == Uvwmap ) then ("map world size") 
							
						else if selection.count == 1 and subobjectLevel== 0 and (classOf Sl == Unwrap_UVW) then ("---") 
						else if selection.count == 1 and subobjectLevel== 1 and (classOf Sl == Unwrap_UVW) then ("Render UV Dialog") 
						else if selection.count == 1 and subobjectLevel== 2 and (classOf Sl == Unwrap_UVW) then ("Seams \nPoinToPoint") 
						else if selection.count == 1 and subobjectLevel== 3 and (classOf Sl == Unwrap_UVW) then ("QuikPlanar") 
							
						else if selection.count == 1 and subobjectLevel== 0 and (classOf Sl == Sweep) then ("Pivot Aligment") 
							
						
						else ("---2---")
							)	
	local _3Text = (
						 if subobjectLevel== 0 and (Cl_edit()) then ("PaintPush")
						else if subobjectLevel== 1 and (Cl_edit()) then ("CUT \nsliP Cnt ")
						else if subobjectLevel== 2 and (Cl_edit()) then ("Chamfer")
						else if subobjectLevel== 3 and (Cl_edit()) then ("Cup")
						else if subobjectLevel== 4 and (Cl_edit()) then ("INSET\nsliP")
						else if subobjectLevel== 5 and (Cl_edit()) then ("Ins polygn")
							
						else if subobjectLevel== 0 and Cl_Spl() then ("Rend in Vwprt")
						else if subobjectLevel== 1 and Cl_Spl() then ("Weld")
						else if subobjectLevel== 2 and Cl_Spl() then ("Detach")
						else if subobjectLevel== 3 and Cl_Spl() then ("Extend Spline")
							
						else if selection.count == 1 and subobjectLevel== 0 and (classOf Sl == Uvwmap ) then ("Manipulate") 
							
						else if selection.count == 1 and subobjectLevel== 0 and (classOf Sl == Unwrap_UVW) then ("RESET all") 
						else if selection.count == 1 and subobjectLevel== 1 and (classOf Sl == Unwrap_UVW) then ("packDialog")
						else if selection.count == 1 and subobjectLevel== 2 and (classOf Sl == Unwrap_UVW) then ("Edje loop sel")
						else if selection.count == 1 and subobjectLevel== 3 and (classOf Sl == Unwrap_UVW) then ("QuikPeel")
							
						else if selection.count == 1 and subobjectLevel== 0 and (classOf Sl == Sweep) then ("Select Shape") 
						else ("---3---")
	
							)	
							
	local _4Text = (
						 if  subobjectLevel== 0 and (Cl_edit()) then ("PaintSmudj")
						else if subobjectLevel== 1 and (Cl_edit()) then ("Extrude")
						else if subobjectLevel== 2 and (Cl_edit()) then ("EXTRUDE\ncreatshpfspl")
						else if subobjectLevel== 3 and (Cl_edit()) then ("CrSh from Edge")
						else if subobjectLevel== 4 and (Cl_edit()) then ("EXTRUDE\nhing")
						else if subobjectLevel== 5 and (Cl_edit()) then ("flipNormals")
							
						else if subobjectLevel== 0 and Cl_Spl() then ("Insert")
						else if subobjectLevel== 1 and Cl_Spl() then ("Break")
						else if subobjectLevel== 2 and Cl_Spl() then ("Break")
						else if subobjectLevel== 3 and Cl_Spl() then ("Tream")
						
						else if subobjectLevel== 0 and (classOf Sl == Turbosmooth ) then ("Iteration 0.1.2")	
							
						else if selection.count == 1 and subobjectLevel== 0 and (classOf Sl == Unwrap_UVW) then ("Flatten mapping") 
						else if selection.count == 1 and subobjectLevel== 1 and (classOf Sl == Unwrap_UVW) then ("Unwarp reset")
						else if selection.count == 1 and subobjectLevel== 2 and (classOf Sl == Unwrap_UVW) then ("Relax tool")
						else if selection.count == 1 and subobjectLevel== 3 and (classOf Sl == Unwrap_UVW) then ("Pelt map")
						
						else if selection.count == 1 and subobjectLevel== 0 and (classOf Sl == Sweep) then ("Built In Section")
							
						else if selection.count == 1 and subobjectLevel== 0 and (classOf Sl == Symmetry) then ("Flip")
							
						else if selection.count == 1 and subobjectLevel== 0 and (classOf Sl == Turbosmooth) then ("Iteration 0.1.2") 
							
						
						else ("---4---")
						
						
							)	
	local _5Text = ( if  (Cl_edit()) then ("SlicePl  xYz")
							else if selection.count == 1 and subobjectLevel== 0 and (classOf Sl == Symmetry) then ("Axis xYz")
							else if selection.count == 1 and subobjectLevel== 0 and (classOf Sl == Arc or classOf Sl == Helix or classOf Sl == Star 	or classOf Sl == Circle or classOf Sl ==  Egg) then ("Conv.EditSpline")
							else if selection.count == 1 and subobjectLevel== 0 and (classOf Sl ==SplineShape or classOf Sl ==Rectangle or classOf Sl == Text or classOf Sl == Donut or classOf Sl ==NGon or classOf Sl ==Ellipse) then ("Conv.EditSpline")
							else if selection.count == 1 and subobjectLevel== 0 and (classOf Sl ==Line or classOf Sl == Section or classOf Sl == Angle or classOf Sl ==Channel or classOf Sl ==Tee) then ("Conv.EditSpline")
							else if selection.count == 1 and subobjectLevel== 0 and (classOf Sl ==WalledRectangle or classOf Sl == WideFlange) then ("Conv.EditSpline")
							else if selection.count == 1 and subobjectLevel== 0 and (classOf Sl ==Uvwmap) then ("Map xYz")
						else ("---Sl---"))
	Local _6Text = ("---")

---------------------------------------------------------------------------------------------------------------------------------------
--------------------------ACTIONS-------------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------------------------------------------------
	--------------------------------------------------------------------------------------------------------------------
	-------------Modelling ----------------
	--------------------------------------------------------------------------------------------------------------------
	fn _ActSoftSel = 		(case classOf Sl of   --- Soft selection
									(Edit_Poly:	( if  $.modifiers[#Edit_Poly].useSoftSel  == true then  ($.modifiers[#Edit_Poly].useSoftSel = off)
									else if  $.modifiers[#Edit_Poly].useSoftSel == false then  ($.modifiers[#Edit_Poly].useSoftSel = on)	)
									Editable_poly:	(if  $.useSoftSel == true then  ($.useSoftSel = off)
									else if  $.useSoftSel == false then  ($.useSoftSel = on))	
									)
								)
	fn _ActIgnBackfac = -- Ignor BackFacing swith--
												(case classOf Sl of
												(Edit_Poly:	( if  $.modifiers[#Edit_Poly].ignoreBackfacing  == true then  ($.modifiers[#Edit_Poly].ignoreBackfacing = off)
												else if  $.modifiers[#Edit_Poly].ignoreBackfacing == false then  ($.modifiers[#Edit_Poly].ignoreBackfacing = on)	)
												Editable_poly:	(if  $.ignoreBackfacing == true then  ($.ignoreBackfacing = off)
												else if  $.ignoreBackfacing== false then  ($.ignoreBackfacing = on))	
												)
												)
	fn _ActSelModSw = (case classOf Sl of
										(	Edit_Poly:	( if $.modifiers[#Edit_Poly].selectMode == 0 then ($.modifiers[#Edit_Poly].selectMode = 1)
															else if $.modifiers[#Edit_Poly].selectMode == 1 then ($.modifiers[#Edit_Poly].selectMode = 0))
										Editable_poly:	(if  $.selectMode == 0 then  ($.selectMode = 1 )
																		else if  $.selectMode == 1 then  ($.selectMode = 0 ))
															)	
									)
	fn _Act_Repeat_Last = (case classOf Sl of
										( 
											Editable_poly: (macros.run "Editable Polygon Object" "EPoly_Repeat_Last")
											Edit_poly:	(macros.run "Editable Polygon Object" "EPoly_Repeat_Last")
											)	
									)
	fn _Act_ConstrainEdg = (case classOf Sl of
										( Editable_poly:(if $.constrainType != 1 then ($.constrainType = 1 )
																else if $.constrainType == 1 then ($.constrainType = 0 ))
										Edit_poly: ( if $.modifiers[#Edit_Poly].constrainType != 1  then  ($.modifiers[#Edit_Poly].constrainType = 1)
														else if $.modifiers[#Edit_Poly].constrainType == 1  then  ($.modifiers[#Edit_Poly].constrainType = 0))
													)																	 
												)
												
	fn _Act_ConstrainFace = (case classOf Sl of
										( Editable_poly:(if $.constrainType != 2 then ($.constrainType = 2 )
																else if $.constrainType == 2 then ($.constrainType = 0 ))
										Edit_poly: ( if $.modifiers[#Edit_Poly].constrainType != 2  then  ($.modifiers[#Edit_Poly].constrainType = 2)
														else if $.modifiers[#Edit_Poly].constrainType == 2  then  ($.modifiers[#Edit_Poly].constrainType = 0))
													)																	 
												)
												
-----------
----BTN-1 -----
-----------
/*
	for Editable poly, Edit poly 
		SubLevel  _0_- Attach
		SubLevel  _1_- Target Weld  (Ctrl - With options)  Slice Plane (Shift)
		SubLevel  _2_-Connect Edge  (Ctrl - With options)  (Shift - With one EdgeSegments )
		SubLevel  _3_-Connect 
		SubLevel  _4_- Bevel (Ctrl - With options) (Shift - Inset)
		SubLevel  _5_- Detach.
	for Spline 
		SubLevel  _0_- Attach
		SubLevel  _1_- Chamfer (Ctrl - Break)
		SubLevel  _2_- Refine
		SubLevel  _3_- Outline
	Uvwmap:
		SubLevel  _0_ Mapping swither
		                      Planar-Cylinrical-Spherical-ShrinkWrap-Box
		SubLevel  _1_- Swith Axis
	Unwrap_UVW:
		SubLevel  _0_ Open UV Editor
		SubLevel  _1_- set Pelt PointToPoint SeamsMode
		SubLevel  _2_-set Pelt Edit SeamsMode
		SubLevel  _3_- Expand PolygonSelection To Seams
	Turbosmooth
			Swith -by smoothing group- (on, off)
	
	Sweep  modifier - Slection type switch
	*/
												
												
												
	fn _Act_1 = (max modify mode
						case classOf Sl of
																(Editable_poly:	  (if SubobjectLevel == 0 then (macros.run "Editable Polygon Object" "EPoly_Attach"	)
																							Else if  SubobjectLevel == 1 then (macros.run "Editable Polygon Object" "EPoly_VTargetWeld")
																							Else if  SubobjectLevel == 2 then (undo "ConnectEdges" on try ($.EditablePoly.ConnectEdges ())catch())
																							else if SubobjectLevel == 3 then (undo "ConnectEdges" on try ($.EditablePoly.ConnectEdges ()) catch() )
																							else if SubobjectLevel == 4 then (macros.run "Ribbon - Modeling" "EPoly_Bevel")
																							else if SubobjectLevel == 5 then (macros.run "Ribbon - Modeling" "GeometryDetach"))
																Edit_poly:	(if SubobjectLevel == 0 then (macros.run "Editable Polygon Object" "EPoly_Attach")
																					else if  SubobjectLevel == 1 then (macros.run "Editable Polygon Object" "EPoly_VTargetWeld")
																					Else if  SubobjectLevel == 2 then ($.modifiers[#Edit_Poly].ButtonOp #ConnectEdges)
																					else if SubobjectLevel == 3 then (macros.run "Editable Polygon Object" "EPoly_Connect2")
																					else if SubobjectLevel == 4 then (macros.run "Ribbon - Modeling" "EPoly_Bevel")
																					else if SubobjectLevel == 5 then (macros.run "Ribbon - Modeling" "GeometryDetach")) 
																SplineShape: (if  SubobjectLevel == 0 then (macros.run "Editable Spline Object" "ESpline_Attach")
																					else if  SubobjectLevel == 1 then (macros.run "Editable Spline Object" "ESpline_VChamfer")
																					else if  SubobjectLevel == 2 then (macros.run "Editable Spline Object" "ESpline_Refine")
																					else if  SubobjectLevel == 3 then (macros.run "Editable Spline Object" "ESpline_Outline"))
																	line: ( if  SubobjectLevel == 0 then (macros.run "Editable Spline Object" "ESpline_Attach")
																			else if   SubobjectLevel == 1 then (macros.run "Editable Spline Object" "ESpline_VChamfer")  
																			else if  SubobjectLevel == 2 then (macros.run "Editable Spline Object" "ESpline_Refine")
																			else if  SubobjectLevel == 3 then (macros.run "Editable Spline Object" "ESpline_Outline"))
																						
																	Uvwmap:	( if  SubobjectLevel == 0 then (
																						if $.modifiers[#UVW_Map].maptype == 0 then ($.modifiers[#UVW_Map].maptype = 1; $.modifiers[#UVW_Map].cap = on) --Cylinrical wtith Cap
																						else if $.modifiers[#UVW_Map].maptype == 1 then $.modifiers[#UVW_Map].maptype = 2    ---Spherical
																						else if $.modifiers[#UVW_Map].maptype == 2 then $.modifiers[#UVW_Map].maptype = 3    ---Shrink Wrap
																						else if $.modifiers[#UVW_Map].maptype == 3 then $.modifiers[#UVW_Map].maptype = 4   -- Box
																						else if $.modifiers[#UVW_Map].maptype == 4 then $.modifiers[#UVW_Map].maptype = 0) -- planar
																					else if   SubobjectLevel == 1 then 
																								(if $.modifiers[#UVW_Map].axis == 0 Then $.modifiers[#UVW_Map].axis = 1
																								else if $.modifiers[#UVW_Map].axis == 1 Then $.modifiers[#UVW_Map].axis = 2
																								else if $.modifiers[#UVW_Map].axis == 2 Then $.modifiers[#UVW_Map].axis = 0
																								)
																					)
																	Unwrap_UVW: (if  SubobjectLevel == 0 then ($.modifiers[Unwrap_UVW].edit())
																		else if  SubobjectLevel == 1 then ( $.modifiers[Unwrap_UVW].setPeltPointToPointSeamsMode true )
																		else if  SubobjectLevel == 2 then  ( If $.modifiers[Unwrap_UVW].getPeltEditSeamsMode()== true then $.modifiers[Unwrap_UVW].setPeltEditSeamsMode off
																														else If $.modifiers[Unwrap_UVW].getPeltEditSeamsMode() == false then $.modifiers[Unwrap_UVW].setPeltEditSeamsMode on
																					)
																		else if  SubobjectLevel == 3 then  ($.modifiers[Unwrap_UVW].peltExpandSelectionToSeams () true)
																						)
																	Turbosmooth: ( if $.modifiers[#TurboSmooth].sepBySmGroups == false then ($.modifiers[#TurboSmooth].sepBySmGroups = on)
																						else if $.modifiers[#TurboSmooth].sepBySmGroups == true then ($.modifiers[#TurboSmooth].sepBySmGroups = off))
																		
																	Sweep: (if $.modifiers[#Sweep].CustomShape == 0 then ($.modifiers[#Sweep].CustomShape = 1)
																						else if  $.modifiers[#Sweep].CustomShape == 1 then ($.modifiers[#Sweep].CustomShape = 0))
																	
																)
														
														
														
															)
	fn _Act_1Ctr = (max modify mode
								case classOf Sl of
																( Editable_poly:	  (if SubobjectLevel == 0 then (macros.run "Editable Polygon Object" "EPoly_Attach")
																							Else if  SubobjectLevel == 1 then (undo "CollapsVertex" on try($.EditablePoly.collapse #Vertex) Catch() )
																							Else if  SubobjectLevel == 2 then (macros.run "Ribbon - Modeling" "ConnectEdgesOptions")
																							else if SubobjectLevel == 3 then (macros.run "Ribbon - Modeling" "ConnectEdgesOptions")
																							else if SubobjectLevel == 4 then (macros.run "Ribbon - Modeling" "EPoly_BevelOptions")
																							else if SubobjectLevel == 5 then (macros.run "Editable Polygon Object" "EPoly_Detach")
																							)
																	Edit_poly:	(if SubobjectLevel == 0 then (macros.run "Editable Polygon Object" "EPoly_Attach")
																					else if  SubobjectLevel == 1 then ($.modifiers[#Edit_Poly].WeldVertices 1 2)
																					Else if  SubobjectLevel == 2 then (macros.run "Ribbon - Modeling" "ConnectEdgesOptions")
																					else if SubobjectLevel == 3 then (macros.run "Ribbon - Modeling" "ConnectEdgesOptions")
																					else if SubobjectLevel == 4 then (macros.run "Ribbon - Modeling" "EPoly_BevelOptions")
																					else if SubobjectLevel == 5 then (macros.run "Editable Polygon Object" "EPoly_Detach"))
																		SplineShape: (if  SubobjectLevel == 1 then (macros.run "Editable Spline Object" "ESpline_Break")
																							)
																		line: ( if   SubobjectLevel == 1 then (macros.run "Editable Spline Object" "ESpline_Break")  
																																												)
																)	
															)
	fn _Act_1Sh = (max modify mode
							case classOf Sl of
																(Editable_poly:	  (if SubobjectLevel == 0 then (macros.run "Editable Polygon Object" "EPoly_Attach")
																							else if SubobjectLevel == 4 then (macros.run "Editable Polygon Object" "EPoly_Quickslice")
																							)
																Edit_poly:	(if SubobjectLevel == 0 then (macros.run "Editable Polygon Object" "EPoly_Attach")
																					else if SubobjectLevel == 4 then (macros.run "Editable Polygon Object" "EPoly_Quickslice")
																					
																					)	
																
																)
															)
															
-----------
----BTN-2 -----
-----------
	/* 
	for Editable poly, Edit poly 
		SubLevel  _0_- Quick Slice
		SubLevel  _1_-  Weld
		SubLevel  _2_-Bridje
		SubLevel  _3_-Bridje
		SubLevel  _4_- Bridje
		SubLevel  _5_- Create Face
	for Spline 
		SubLevel  _0_- Create Line
		SubLevel  _1_- Fillet
		SubLevel  _2_- Divide
		SubLevel  _3_- Close Spline
	Uvwmap: 
		SubLevel  _0_-Real map world size switch
	Unwarp UvW -- RESET all
	Sweep - Swith Pivot Aligment
*/
		fn _Act_2 = ( max modify mode
							case classOf Sl of
											( 
																				Editable_poly:	  (if SubobjectLevel == 0 then (macros.run "Editable Polygon Object" "EPoly_Quickslice")
																										Else if  SubobjectLevel == 1 then (macros.run "Ribbon - Modeling" "EPoly_WeldOptions")
																										Else if  SubobjectLevel == 2 then (undo "BridjeEdg" on try ($.EditablePoly.Bridge ()) Catch())
																										else if SubobjectLevel == 3 then (undo "BridjeEdg" on try ($.EditablePoly.Bridge ()) Catch())
																										else if SubobjectLevel == 4 then (undo "BridjeEdg" on try ($.EditablePoly.Bridge ()) Catch())
																										else if SubobjectLevel == 5 then (macros.run "Editable Polygon Object" "EPoly_Create")
																										)
																										
																										 
																				Edit_poly:	(if SubobjectLevel == 0 then (macros.run "Editable Polygon Object" "EPoly_Quickslice")
																								else if  SubobjectLevel == 1 then (macros.run "Ribbon - Modeling" "EPoly_WeldOptions")
																								Else if  SubobjectLevel == 2 then (undo "BridjeEdg" on try ($.modifiers[#Edit_Poly].ButtonOp #BridgeEdge) Catch())
																								else if SubobjectLevel == 3 then ($.modifiers[#Edit_Poly].ButtonOp #BridgeEdge)
																								else if SubobjectLevel == 4 then ($.modifiers[#Edit_Poly].ButtonOp #BridgePolygon)
																								else if SubobjectLevel == 5 then (macros.run "Editable Polygon Object" "EPoly_Create"))
																				SplineShape: (if  SubobjectLevel == 0 then (macros.run "Editable Spline Object" "ESpline_Create_Line")
																								else if  SubobjectLevel == 1 then (macros.run "Editable Spline Object" "ESpline_Fillet")
																								else if  SubobjectLevel == 2 then (macros.run "Editable Spline Object" "ESpline_Divide")
																								else if  SubobjectLevel == 3 then (macros.run "Editable Spline Object" "ESpline_Close"))
																				line: ( if  SubobjectLevel == 0 then (macros.run "Editable Spline Object" "ESpline_Create_Line")
																						else if   SubobjectLevel == 1 then (macros.run "Editable Spline Object" "ESpline_Fillet")  
																						else if  SubobjectLevel == 2 then (macros.run "Editable Spline Object" "ESpline_Divide")
																						else if  SubobjectLevel == 3 then (macros.run "Editable Spline Object" "ESpline_Close")
																						)
																				Uvwmap:	(if $.modifiers[#UVW_Map].realWorldMapSize == false then ($.modifiers[#UVW_Map].realWorldMapSize =on) 
																								else if $.modifiers[#UVW_Map].realWorldMapSize == true then ($.modifiers[#UVW_Map].realWorldMapSize =off) 
																								)
																				
																				Unwrap_UVW: (if  SubobjectLevel == 0 then (null) 
																									else if  SubobjectLevel == 1 then ($.modifiers[Unwrap_UVW].renderUVDialog() )
																									else if  SubobjectLevel == 2 then ($.modifiers[#unwrap_uvw].setPeltPointToPointSeamsMode on)
																									else if  SubobjectLevel == 3 then ($.modifiers[#unwrap_uvw].planarMap() )
																									)
																					Sweep: ($.modifiers[#Sweep].alignPivot())
																		)
																	)
	fn _Act_2Ctr = ( max modify mode
							case classOf Sl of
																	( 
																				Editable_poly:	  (if SubobjectLevel == 0 then (macros.run "Editable Polygon Object" "EPoly_Quickslice")
																										Else if  SubobjectLevel == 1 then (macros.run "Ribbon - Modeling" "EPoly_WeldOptions")
																										Else if  SubobjectLevel == 2 then (macros.run "Ribbon - Modeling" "EdgeBridgeOptions")
																										else if SubobjectLevel == 3 then (macros.run "Ribbon - Modeling" "EdgeBridgeOptions")
																										else if SubobjectLevel == 4 then (macros.run "Ribbon - Modeling" "PolyBridgeOptions")
																										else if SubobjectLevel == 5 then (macros.run "Editable Polygon Object" "EPoly_Create")
																										)
																				Edit_poly:	(if SubobjectLevel == 0 then (macros.run "Editable Polygon Object" "EPoly_Quickslice")
																								else if  SubobjectLevel == 1 then (macros.run "Ribbon - Modeling" "EPoly_WeldOptions")
																								Else if  SubobjectLevel == 2 then (macros.run "Ribbon - Modeling" "EdgeBridgeOptions")
																								else if SubobjectLevel == 3 then (macros.run "Ribbon - Modeling" "EdgeBridgeOptions")
																								else if SubobjectLevel == 4 then (macros.run "Ribbon - Modeling" "PolyBridgeOptions")
																								else if SubobjectLevel == 5 then (macros.run "Editable Polygon Object" "EPoly_Create"))

																		)
																	)
	fn  _Act_2Sh= ( max modify mode
							case classOf Sl of
											( 
																				Editable_poly:	  (if SubobjectLevel == 0 then ()
																										else if SubobjectLevel == 4 then (macros.run "Editable Polygon Object" "EPoly_Create")
																										)
																										
																										 
																				Edit_poly:	(if SubobjectLevel == 0 then ()
																								else if SubobjectLevel == 4 then (macros.run "Editable Polygon Object" "EPoly_Create")
																								)
											)
						)
												
-----------
----BTN-3 -----
-----------
																					/* 

															for Editable poly, Edit poly 
															SubLevel  _0_- PaintDeformPushPull
															SubLevel  _1_-  Cut
															SubLevel  _2_-Chamfer
															SubLevel  _3_-Cup
															SubLevel  _4_- Inset
															SubLevel  _5_- Inset for polygon
														for Spline 
															SubLevel  _0_- Rendarable in Viewport and Render Switcher
															SubLevel  _1_- Weld
															SubLevel  _2_- Detach
															SubLevel  _3_- Extend Spline
														Unwrap_UVW: 
															SubLevel  _0_- Render UV Dialog
															SubLevel  _1_- packDialog
															SubLevel  _2_- Edje loop selection
															SubLevel  _3_- 
														Sweep - Select Custom Shape for profile
	
															*/
					
												
	fn _Act_3 = (max modify mode
							( case classOf Sl of
																( 
																			Editable_poly:	  (if SubobjectLevel == 0 then (macros.run "PolyTools" "PaintDeformPushPull")
																									Else if  SubobjectLevel == 1 then (macros.run "Editable Polygon Object" "EPoly_Cut")
																									Else if  SubobjectLevel == 2 then (macros.run "Ribbon - Modeling" "EPoly_Chamfer")
																									else if SubobjectLevel == 3 then ($.EditablePoly.capHoles #Edge)
																									else if SubobjectLevel == 4 then (macros.run "Ribbon - Modeling" "EPoly_Inset")
																									else if SubobjectLevel == 5 then (macros.run "Ribbon - Modeling" "EPoly_Inset")
																									)
																			Edit_poly:	(if SubobjectLevel == 0 then (macros.run "PolyTools" "PaintDeformPushPull")
																							else if  SubobjectLevel == 1 then (macros.run "Editable Polygon Object" "EPoly_Cut")
																							Else if  SubobjectLevel == 2 then (macros.run "Ribbon - Modeling" "EPoly_Chamfer")
																							else if SubobjectLevel == 3 then ($.modifiers[#Edit_Poly].ButtonOp #Cap)
																							else if SubobjectLevel == 4 then (macros.run "Ribbon - Modeling" "EPoly_Inset")
																							else if SubobjectLevel == 5 then (macros.run "Ribbon - Modeling" "EPoly_Inset"))
																				
																			SplineShape: (if  SubobjectLevel == 0 then (				(if  $.render_renderable== true then  ($.render_renderable = off; $.render_displayRenderMesh= off) 
																					else if  $.render_renderable== false then  ($.render_renderable = on;  $.render_displayRenderMesh = on)))
																							else if  SubobjectLevel == 1 then (macros.run "Editable Spline Object" "ESpline_Weld")
																							else if  SubobjectLevel == 2 then (macros.run "Editable Spline Object" "ESpline_Detach_Segment")
																							else if  SubobjectLevel == 3 then (macros.run "Editable Spline Object" "ESpline_Extend"))
																			line: ( if  SubobjectLevel == 0 then (if  $.render_renderable== true then  ($.render_renderable = off; $.render_displayRenderMesh= off) 
																														else if  $.render_renderable== false then  ($.render_renderable = on;  $.render_displayRenderMesh = on) )
																					else if   SubobjectLevel == 1 then (macros.run "Editable Spline Object" "ESpline_Weld")  
																					else if  SubobjectLevel == 2 then (macros.run "Editable Spline Object" "ESpline_Detach_Segment")
																					else if  SubobjectLevel == 3 then (macros.run "Editable Spline Object" "ESpline_Extend")
																					)
																			Unwrap_UVW: (if  SubobjectLevel == 0 then ($.modifiers[#unwrap_uvw].unwrap.reset ();
																										subobjectLevel = 3; max select all;	actionMan.executeAction 0 "40021";
																										$.modifiers[Unwrap_UVW].mappingMode 0;
																										$.modifiers[Unwrap_UVW].mappingMode 1;
																										$.modifiers[Unwrap_UVW].mappingMode 0;
																										subobjectLevel =0
																										clearselection ())
																				else if  SubobjectLevel == 1 then ($.modifiers[Unwrap_UVW].packDialog() )
																				else if  SubobjectLevel == 2 then  ($.modifiers[Unwrap_UVW].geomEdgeLoopSelection() true)
																				else if  SubobjectLevel == 3 then  ($.modifiers[Unwrap_UVW].LSCMSolve())
																					) 
																			Uvwmap:	(actionMan.executeAction 0 "59225" )  -- Tools: Select and Manipulate
																			Sweep: ((if $.modifiers[#Sweep].CustomShape == 0 then ($.modifiers[#Sweep].CustomShape = 1);
																				$.modifiers[#Sweep].pickCustomSection())
																			)	
																	)
																)
															
														)	

	fn _Act_3Ctr 	= ( max modify mode
								case classOf Sl of
																( 
																			Editable_poly:	  (if SubobjectLevel == 0 then ()
																									Else if  SubobjectLevel == 1 then (macros.run "Editable Polygon Object" "EPoly_Connect")
																									Else if  SubobjectLevel == 2 then (macros.run "Ribbon - Modeling" "EPoly_ChamferOptions")
																									else if SubobjectLevel == 3 then ($.EditablePoly.capHoles #Edge)
																									else if SubobjectLevel == 4 then (macros.run "Ribbon - Modeling" "EPoly_InsetOptions")
																									else if SubobjectLevel == 5 then (macros.run "Ribbon - Modeling" "EPoly_InsetOptions")
																									)
																			Edit_poly:	(if SubobjectLevel == 0 then (	
																													)
																							else if  SubobjectLevel == 1 then (macros.run "Editable Polygon Object" "EPoly_Connect")
																							else if  SubobjectLevel == 2 then (macros.run "Ribbon - Modeling" "EPoly_ChamferOptions")
																							else if SubobjectLevel == 3 then ($.modifiers[#Edit_Poly].ButtonOp #Cap)
																							else if SubobjectLevel == 4 then (macros.run "Ribbon - Modeling" "EPoly_InsetOptions")
																							else if SubobjectLevel == 5 then (macros.run "Ribbon - Modeling" "EPoly_InsetOptions"))
	
																	)
																)	

	fn _Act_3Sh 	=		(max modify mode
								case classOf Sl of
																( 
																			Editable_poly:	  (if SubobjectLevel == 0 then ()
																									Else if  SubobjectLevel == 1 then (macros.run "Ribbon - Modeling" "CutsSlicePlane")
																									Else if  SubobjectLevel == 4 then (macros.run "Ribbon - Modeling" "CutsSlicePlane")
																									)
																			Edit_poly:	(if SubobjectLevel == 0 then (	
																													)
																							else if  SubobjectLevel == 1 then (macros.run "Ribbon - Modeling" "CutsSlicePlane")
																							else if  SubobjectLevel == 4 then (macros.run "Ribbon - Modeling" "CutsSlicePlane")
										)
	
																	)
		
		
		
		
		)
																								
																								
-----------
----BTN-4 -----
-----------
															/*Ctrl+ D

for Editable poly, Edit poly 
		SubLevel  _0_- PaintDeformSmudge
		SubLevel  _1_-  Extrude
		SubLevel  _2_- Extrude
		SubLevel  _3_- Create Shape from Edge You Can choose the first select edje after use it
		SubLevel  _4_- Extrude 
		SubLevel  _5_- flipNormals 
	for Spline 
		SubLevel  _0_- Extrude modify
		SubLevel  _1_- Lathe modify
		SubLevel  _2_- Sweep modify
		SubLevel  _3_- Loft Compound Object
	Unwrap_UVW:`
		SubLevel  _0_- Flatten mapping
		SubLevel  _1_- Unwarp reset
		SubLevel  _2_- Relax tool
		SubLevel  _3_- Pelt map
	Turbosmooth: - Set Iteration 0.1.2
	Symmetry: Flip Switcher 
	Sweep: Current Built In Section
*/
fn _Act_4 = (max modify mode
					case classOf Sl of
															( 
																		Editable_poly:	  (if SubobjectLevel == 0 then (macros.run "PolyTools" "PaintDeformSmudge")
																								Else if  SubobjectLevel == 1 then (macros.run "Editable Polygon Object" "EPoly_Extrude")
																								Else if  SubobjectLevel == 2 then (macros.run "Editable Polygon Object" "EPoly_Extrude")
																								else if SubobjectLevel == 3 then (macros.run "Editable Polygon Object" "EPoly_ShapeFromEdges")
																								else if SubobjectLevel == 4 then (macros.run "Editable Polygon Object" "EPoly_Extrude")
																								else if SubobjectLevel == 5 then (macros.run "Editable Polygon Object" "EPoly_Flip")
																								)
																		Edit_poly:	(if SubobjectLevel == 0 then (macros.run "PolyTools" "PaintDeformSmudge")
																						else if  SubobjectLevel == 1 then (macros.run "Editable Polygon Object" "EPoly_Extrude")
																						Else if  SubobjectLevel == 2 then (macros.run "Editable Polygon Object" "EPoly_Extrude")
																						else if SubobjectLevel == 3 then (macros.run "Editable Polygon Object" "EPoly_ShapeFromEdges")
																						else if SubobjectLevel == 4 then (macros.run "Editable Polygon Object" "EPoly_Extrude")
																						else if SubobjectLevel == 5 then (macros.run "Editable Polygon Object" "EPoly_Flip"))
																		SplineShape: (if  SubobjectLevel == 0 then (splineOps.startInsert $) --(macros.run "Modifiers" "Extrude")
																						else if  SubobjectLevel == 1 then (splineOps.startBreak $) --(modPanel.addModToSelection (Lathe ()) ui:on; $.modifiers[#Lathe].weldCore = on)
																						else if  SubobjectLevel == 2 then (splineOps.startBreak $) --(macros.run "Modifiers" "SweepMod")
																						else if  SubobjectLevel == 3 then (splineOps.startTrim $) --(macros.run "Objects Compounds" "Loft")
																							)
																		line: ( if  SubobjectLevel == 0 then (splineOps.startInsert $) --(macros.run "Modifiers" "Extrude")
																				else if   SubobjectLevel == 1 then (splineOps.startBreak $) -- (modPanel.addModToSelection (Lathe ()) ui:on; $.modifiers[#Lathe].weldCore = on)  
																				else if  SubobjectLevel == 2 then (splineOps.startBreak $) --(macros.run "Modifiers" "SweepMod")
																				else if  SubobjectLevel == 3 then (splineOps.startTrim $) --(macros.run "Objects Compounds" "Loft")
																		)
																
																				Unwrap_UVW: (if  SubobjectLevel == 0 then (actionMan.executeAction 2077580866 "40047" )
																						else if  SubobjectLevel == 1 then ( $.modifiers[#unwrap_uvw].unwrap.reset ()) 
																						else if  SubobjectLevel == 2 then  (actionMan.executeAction 2077580866 "40136") --relax tool
																						else if  SubobjectLevel == 3 then  ($.modifiers[Unwrap_UVW].mappingMode 5)  -- Pelt map dialog
																					)
																			Turbosmooth: ( if $.modifiers[#TurboSmooth].iterations == 0 then $.modifiers[#TurboSmooth].iterations = 1
																									else if $.modifiers[#TurboSmooth].iterations == 1 then $.modifiers[#TurboSmooth].iterations = 2
																										else if $.modifiers[#TurboSmooth].iterations == 2 then $.modifiers[#TurboSmooth].iterations = 3
																											else if $.modifiers[#TurboSmooth].iterations == 3 then $.modifiers[#TurboSmooth].iterations = 0
																			)
																			Symmetry: (if $.modifiers[#Symmetry].flip == off then $.modifiers[#Symmetry].flip = on
																			else if $.modifiers[#Symmetry].flip == on then $.modifiers[#Symmetry].flip = off
																							)
																			Sweep: (if $.modifiers[#Sweep].CurrentBuiltInShape == 1 then $.modifiers[#Sweep].CurrentBuiltInShape = 2
																			else if $.modifiers[#Sweep].CurrentBuiltInShape == 2 then $.modifiers[#Sweep].CurrentBuiltInShape = 3
																				else if $.modifiers[#Sweep].CurrentBuiltInShape == 3 then $.modifiers[#Sweep].CurrentBuiltInShape = 4
																				else if $.modifiers[#Sweep].CurrentBuiltInShape == 4 then $.modifiers[#Sweep].CurrentBuiltInShape = 5
																				else if $.modifiers[#Sweep].CurrentBuiltInShape == 5 then $.modifiers[#Sweep].CurrentBuiltInShape = 6
																				else if $.modifiers[#Sweep].CurrentBuiltInShape == 6 then $.modifiers[#Sweep].CurrentBuiltInShape = 7
																				else if $.modifiers[#Sweep].CurrentBuiltInShape == 7 then $.modifiers[#Sweep].CurrentBuiltInShape = 8
																				else if $.modifiers[#Sweep].CurrentBuiltInShape == 8 then $.modifiers[#Sweep].CurrentBuiltInShape = 9
																				else if $.modifiers[#Sweep].CurrentBuiltInShape == 9 then $.modifiers[#Sweep].CurrentBuiltInShape = 10
																				else if $.modifiers[#Sweep].CurrentBuiltInShape == 10 then $.modifiers[#Sweep].CurrentBuiltInShape = 11
																				else if $.modifiers[#Sweep].CurrentBuiltInShape == 11 then $.modifiers[#Sweep].CurrentBuiltInShape = 12
																				else if $.modifiers[#Sweep].CurrentBuiltInShape == 12 then $.modifiers[#Sweep].CurrentBuiltInShape = 1)
																		)
																)											
fn _Act_4Ctr = (max modify mode
																	case classOf Sl of
															( 
																		Editable_poly:	  (if SubobjectLevel == 0 then ()
																								Else if  SubobjectLevel == 1 then (macros.run "Ribbon - Modeling""EPoly_ExtrudeOptions")
																								Else if  SubobjectLevel == 2 then (macros.run "Ribbon - Modeling" "EPoly_ExtrudeOptions")
																								else if SubobjectLevel == 3 then (macros.run "Ribbon - Modeling" "EPoly_ShapeFromEdgesOptions")
																								else if SubobjectLevel == 4 then (macros.run "Ribbon - Modeling" "EPoly_ExtrudeOptions")
																								else if SubobjectLevel == 5 then (macros.run "Editable Polygon Object" "EPoly_Flip")
																								)
																		Edit_poly:	(if SubobjectLevel == 0 then (	)
																						else if  SubobjectLevel == 1 then (macros.run "Ribbon - Modeling" "EPoly_ExtrudeOptions")
																						Else if  SubobjectLevel == 2 then (macros.run "Ribbon - Modeling" "EPoly_ExtrudeOptions")
																						else if SubobjectLevel == 3 then (macros.run "Ribbon - Modeling" "EPoly_ShapeFromEdgesOptions")
																						else if SubobjectLevel == 4 then (macros.run "Ribbon - Modeling" "EPoly_ExtrudeOptions")
																						else if SubobjectLevel == 5 then (macros.run "Editable Polygon Object" "EPoly_Flip"))

																)
															)
fn _Act_4Sh = (max modify mode
						case classOf Sl of
																		( 
																			Editable_poly:	  ( if  SubobjectLevel == 1 then ($.EditablePoly.ConnectVertices ())
																								else if SubobjectLevel == 2 then (macros.run "Editable Polygon Object" "EPoly_ShapeFromEdges")
																									else if SubobjectLevel == 4 then (macros.run "Ribbon - Modeling" "EPoly_HingeOptions")
																									)
																			Edit_poly:	(if   SubobjectLevel == 1 then ($.modifiers[#Edit_Poly].ButtonOp #ConnectVertices)
																				else if SubobjectLevel == 2 then (macros.run "Editable Polygon Object" "EPoly_ShapeFromEdges")
																							else if SubobjectLevel == 4 then (macros.run "Ribbon - Modeling" "EPoly_HingeOptions")
																				)
																		)
																								)
																								
-----------
----BTN-GROUP -----
-----------	
/*
							Pressed -  open group / Clouse Group
							With Shift - Atach to group
							Wtith Ctrl - Detach
							Ctrl+Shift - ungroup			
							*/
	fn _Act_Group = (try	( for each in $ do 
										( if isGrouphead each and $ != isOpengrouphead each  then (actionMan.executeAction 0 "40142" )   -- Groups: Group Open-- 
											else if  (isOpengroupmember each) or (isOpengrouphead each)  then  (actionMan.executeAction 0 "40143" )   -- Groups: Group CLOSE  
											
											
											)
															) catch	()   )
	fn _Act_GroupCtr = (actionMan.executeAction 0 "40144") -- Groups: Group Detach
	fn _Act_GroupSh = (actionMan.executeAction 0 "40146" )  -- Groups: Group Attach
	fn _Act_GroupShCtr = (actionMan.executeAction 0 "40141")  -- Groups: Ungroup
	fn _Act_GroupAlt = (actionMan.executeAction 0 "40143") -- Groups: Close
															
-----------
----BTN-Sli -----
-----------	
/*
							Edit Poly: Slice plane  (switch align x, y, z - with LeftMouse, MiddleMouse, RightMouse)
							Symmetry:  Axis Switcher  (switch align x, y, z - with LeftMouse, MiddleMouse, RightMouse)
							*/
												
	fn _Act_Sli_Lft=  (max modify mode
						if selection.count ==1 then
							case classOf Sl of ( 
																			Editable_poly:	  (if SubobjectLevel == 1 or SubobjectLevel == 2 or SubobjectLevel == 3 or SubobjectLevel == 4 or SubobjectLevel == 5 then (macros.run "Ribbon - Modeling" "CutsSlicePlane" ; $.EditablePoly.setSlicePlane [1,0,0] [0,0,10] 1.0)
																									else if  SubobjectLevel == 4 or SubobjectLevel == 5 then (macros.run "Ribbon - Modeling" "CutsSlicePlane" ; $.EditablePoly.setSlicePlane [1,0,0] [0,0,10] 1.0)
																									)
																			Edit_poly:	(if   SubobjectLevel == 1 or SubobjectLevel == 2 or SubobjectLevel == 3 or SubobjectLevel == 4 or SubobjectLevel == 5 then (macros.run "Ribbon - Modeling" "CutsSlicePlane" ; $.modifiers[#Edit_Poly].SetSlicePlane [1,0,0] [0,0,2])
																								)
																			Symmetry: (if $.modifiers[#Symmetry].axis != 2 then $.modifiers[#Symmetry].axis = 2)
																								
																			Uvwmap: ($.modifiers[#UVW_Map].axis = 0)
																								
																								
																			Arc: (convertTo $ SplineShape)
																			Helix: (convertTo $ SplineShape)
																			Star: (convertTo $ SplineShape)
																			Circle: (convertTo $ SplineShape)
																			Line: (convertTo $ SplineShape)
																			Rectangle: (convertTo $ SplineShape)
																			Text: (convertTo $ SplineShape) 
																			Donut: (convertTo $ SplineShape)
																			NGon: (convertTo $ SplineShape)
																			Ellipse: (convertTo $ SplineShape)
																			Line: (convertTo $ SplineShape)
																			Section: (convertTo $ SplineShape)
																			Angle: (convertTo $ SplineShape)
																			Channel: (convertTo $ SplineShape)
																			Tee: (convertTo $ SplineShape)
																			WalledRectangle: (convertTo $ SplineShape)
																			WideFlange: (convertTo $ SplineShape)	
																		)
								else if selection.count >1 then (messagebox "Select one object")
																								)
						
					
																		
	fn _Act_Sli_Mdl=  (max modify mode
						if selection.count ==1 then
						case classOf Sl of( 
																			Editable_poly:	  ( if  SubobjectLevel == 1 or SubobjectLevel == 2 or SubobjectLevel == 3 or SubobjectLevel == 4 or SubobjectLevel == 5  then (macros.run "Ribbon - Modeling" "CutsSlicePlane" ; $.EditablePoly.setSlicePlane [0,1,0] [0,0,10] 1.0)
																										)
																			Edit_poly:	(if  SubobjectLevel == 1 or SubobjectLevel == 2 or SubobjectLevel == 3 or SubobjectLevel == 4 or SubobjectLevel == 5  then (macros.run "Ribbon - Modeling" "CutsSlicePlane" ; $.modifiers[#Edit_Poly].SetSlicePlane [0,1,0] [0,0,2])
																								)
																			Symmetry: (if $.modifiers[#Symmetry].axis != 1 then $.modifiers[#Symmetry].axis = 1)
																			Uvwmap: ($.modifiers[#UVW_Map].axis = 1)
																								)
																		
							else if selection.count >1 then (messagebox "Select one object")
																								)
				
																		
																								
	fn _Act_Sli_Rgh=  (max modify mode
						if selection.count ==1 then
						case classOf Sl of
							( 
																			Editable_poly:	  ( if  SubobjectLevel == 1 or SubobjectLevel == 2 or SubobjectLevel == 3 or SubobjectLevel == 4 or SubobjectLevel == 5  then (macros.run "Ribbon - Modeling" "CutsSlicePlane" ; $.EditablePoly.setSlicePlane [0,0,1] [0,0,10] 1.0)
																									
																									)
																			Edit_poly:	(if   SubobjectLevel == 1 or SubobjectLevel == 2 or SubobjectLevel == 3 or SubobjectLevel == 4 or SubobjectLevel == 5  then (macros.run "Ribbon - Modeling" "CutsSlicePlane" ; $.modifiers[#Edit_Poly].SetSlicePlane [0,0,1] [0,0,2])
																								)
																			Symmetry: (if $.modifiers[#Symmetry].axis != 0 then $.modifiers[#Symmetry].axis = 0)
																			Uvwmap: ($.modifiers[#UVW_Map].axis = 2)
																		)
								else if selection.count >1 then (messagebox "Select one object")
																								)
						
	fn _Act_Sli_LftCtr=  (max modify mode
						if selection.count ==1 then
							case classOf Sl of ( 
																			Editable_poly:($.EditablePoly.MakePlanarIn #X)
																				Edit_poly: ($.modifiers[#Edit_Poly].ButtonOp #MakePlanarInX)
							)
						)
						
	fn _Act_Sli_MdlCtr=  (max modify mode
						if selection.count ==1 then
							case classOf Sl of ( 
																			Editable_poly:($.EditablePoly.MakePlanarIn #Y)
																			Edit_poly: ($.modifiers[#Edit_Poly].ButtonOp #MakePlanarInY)
							)
						)
	fn _Act_Sli_RghCtr=  (max modify mode
						if selection.count ==1 then
							case classOf Sl of ( 
																			Editable_poly:($.EditablePoly.MakePlanarIn #Z)
																				Edit_poly: ($.modifiers[#Edit_Poly].ButtonOp #MakePlanarInZ)
							)
						)
																		
----------------------------------------------------------------------------------------------------------------------------------------------
----------------------------ROLLOUT---------------------------------------
----------------------------------------------------------------------------------------------------------------------------------------------							
	rollout _SvDialogF "flat dialog"  height:120 width:180
		(
			
		
			timer t interval:2000 active:True 
			
			--dotNetControl _Telo "System.Windows.Forms.label" align:#center height:95 width:180 pos:[0, 0]
			dotNetControl Btn1 "System.Windows.Forms.Button" align:#center height:30 width:60 pos:[60, 30]   --- fgcolor: (color 250 200 220) --- sozdaniye LIST knopki
			dotNetControl Btn2 "System.Windows.Forms.Button" align:#center height:30 width:60 pos:[0, 60] 
			dotNetControl Btn3 "System.Windows.Forms.Button" align:#center height:30 width:60 pos:[120, 60]
			dotNetControl Btn4 "System.Windows.Forms.Button" align:#center height:30 width:60 pos:[60, 90]
			dotNetControl BtnM "System.Windows.Forms.Button" align:#center height:30 width:60 pos:[60, 60]
			dotNetControl BtnGr "System.Windows.Forms.Button" align:#center height:30 width:60 pos:[0, 90]
			dotNetControl BtnSli "System.Windows.Forms.Button" align:#center height:30 width:55 pos:[120, 30]
			dotNetControl BtnMdf "System.Windows.Forms.Button" align:#center height:30 width:50 pos:[120, 90]
			dotNetControl BtnHelpQ "System.Windows.Forms.Button" align:#center height:30 width:5 pos:[175, 30]
			
			dotNetControl Gr1 "System.Windows.Forms.Button" align:#center height:30 width:30 pos:[0, 30]
			dotNetControl Gr2 "System.Windows.Forms.Button" align:#center height:30 width:30 pos:[30, 30]
			
			dotNetControl Lvl1 "System.Windows.Forms.Button" align:#center height:30 width:36 pos:[0, 0]
			dotNetControl Lvl2 "System.Windows.Forms.Button" align:#center height:30 width:36 pos:[36, 0]
			dotNetControl Lvl3 "System.Windows.Forms.Button" align:#center height:30 width:36 pos:[72, 0]
			dotNetControl Lvl4 "System.Windows.Forms.Button" align:#center height:30 width:36 pos:[108, 0]
			dotNetControl Lvl5 "System.Windows.Forms.Button" align:#center height:30 width:36 pos:[144, 0]
			

-----------------------------------------------------------------------------
-----zapusk funkciy pri open
-----------------------------------------------------------------------------
			on _SvDialogF open do (
			

			max modify mode	
			if ::_Mssg != undefined do try(destroydialog _Mssg) catch()
			if ::_Mdfr != undefined do try(destroydialog  _Mdfr) catch()
			if ::_HelpMsgQ != undefined do try(destroydialog _HelpMsgQ) catch()

			(mp = mouse.screenpos - [_SvDialogF.width-90, _SvDialogF.height-50] ---- Posiciya ot Mouse
							SetDialogPos _SvDialogF mp)
			

			(Btn1.backColor = _FColr  ) --- Cvet fona Front
			Btn1.ForeColor = _TxColr
			Btn1.FlatAppearance.BorderSize = 0
			Btn1.FlatStyle = Btn1.FlatStyle.Flat
			Btn1.Font = _FStyle
			Btn1.Text = _1Text	
			Btn1.BringToFront()
							
			(Btn2.backColor = _FColr  )  --- Top
			Btn2.ForeColor = _TxColr
			Btn2.FlatAppearance.BorderSize = 0
			Btn2.FlatStyle = Btn1.FlatStyle.Flat
			Btn2.Font = _FStyle
			Btn2.Text =  _2Text							
				
				
			(Btn3.backColor = _FColr  )  --- Cvet fona Front
			Btn3.ForeColor = _TxColr
			Btn3.FlatAppearance.BorderSize = 0
			Btn3.FlatStyle = Btn1.FlatStyle.Flat
			Btn3.Font = _FStyle
			Btn3.Text = _3Text	
							
			(Btn4.backColor = _FColr  )  --- Cvet fona Front
			Btn4.ForeColor = _TxColr
			Btn4.FlatAppearance.BorderSize = 0
			Btn4.FlatStyle = Btn1.FlatStyle.Flat
			Btn4.Font = _FStyle
			Btn4.Text = _4Text	
			
			BtnM.backColor = _BColr  --- Cvet fona Front
			BtnM.ForeColor = _TxColr
			BtnM.FlatAppearance.BorderSize = 1
			BtnM.FlatStyle = BtnM.FlatStyle.Flat
			
			BtnGr.backColor = _BColr 
			BtnGr.ForeColor = _TxColr
			BtnGr.FlatAppearance.BorderSize = 0
			BtnGr.FlatStyle = BtnGr.FlatStyle.Flat
			BtnGr.Font = _FStyle
			BtnGr.Text = "Group"

			BtnSli.backColor = _BColr   --- Cvet fona Front
			BtnSli.ForeColor = _TxColr
			BtnSli.FlatAppearance.BorderSize = 0
			BtnSli.FlatStyle = Btn1.FlatStyle.Flat
			BtnSli.Font = _FStyle
			BtnSli.Text = _5Text	
			
			BtnMdf.backColor = _BColr   --- Cvet fona Front
			BtnMdf.ForeColor = _TxColr
			BtnMdf.FlatAppearance.BorderSize = 0
			BtnMdf.FlatStyle = BtnMdf.FlatStyle.Flat
			BtnMdf.Font = _FStyle
			BtnMdf.Text = "Modifr"


			BtnHelpQ.backColor = _HlpColr  --- Cvet fona Front
			BtnHelpQ.ForeColor = _TxColr
			BtnHelpQ.FlatAppearance.BorderSize = 0
			BtnHelpQ.FlatStyle = BtnHelpQ.FlatStyle.Flat

			
			Gr1.backColor = _BColr   --- Cvet fona Front
			Gr1.ForeColor = _TxColr
			Gr1.FlatAppearance.BorderSize = 0
			Gr1.FlatStyle = Gr1.FlatStyle.Flat
			Gr1.Font = _FStyle
			Gr1.Text = "<"
			
			Gr2.backColor = _BColr   --- Cvet fona Front
			Gr2.ForeColor = _TxColr
			Gr2.FlatAppearance.BorderSize = 0
			Gr2.FlatStyle = Gr1.FlatStyle.Flat
			Gr2.Font = _FStyle
			Gr2.Text = ">"
			
			
			
			
			Lvl1.backColor = _LvlColr1   --- Cvet fona Front
			Lvl1.FlatStyle = Btn1.FlatStyle.Flat
			Lvl1.Font = _FStyle
			Lvl1.Text = "1"	
						
			Lvl2.backColor = _LvlColr2  --- Cvet fona Front
			Lvl2.FlatStyle = Btn1.FlatStyle.Flat
			Lvl2.Font = _FStyle
			Lvl2.Text = "2"	
						
			Lvl3.backColor = _LvlColr3  --- Cvet fona Front
			Lvl3.FlatStyle = Btn1.FlatStyle.Flat
			Lvl3.Font = _FStyle
			Lvl3.Text = "3"
			
			Lvl4.backColor = _LvlColr4  --- Cvet fona Front
			Lvl4.FlatStyle = Btn1.FlatStyle.Flat
			Lvl4.Font = _FStyle
			Lvl4.Text = "4"
			
			Lvl5.backColor = _LvlColr5  --- Cvet fona Front
			Lvl5.FlatStyle = Btn1.FlatStyle.Flat
			Lvl5.Font = _FStyle
			Lvl5.Text = "5"
			
---------------------------------------------------
---------------------------------------------------
			-----
			BtnM.refresh()  --- bez etogo ne rabotaet knopki tipo goryachih klavish
			BtnM.focus()
			-----
		)

-------------------------------------------------------------------------------------------------
		--------------------ACTION PRESS BUTTONS-------------------------------------
------------------------------------------------------------------------------------------------

													

		
			on BtnM Mousedown arg do (
						case arg.Button of
											(
						(arg.Button.Left):		(if (keyboard.shiftPressed and keyboard.controlPressed) then (_ActIgnBackfac()
															Destr() MssgQ2 () )
														else if keyboard.controlPressed then (  )
														else if keyboard.shiftPressed then (_ActSoftSel() --- Soft Selection
														Destr() MssgQ3 () )
														else (_ActSelModSw() Destr())	
														Destr())
							
												
						(arg.Button.Middle):		(if (keyboard.shiftPressed and keyboard.controlPressed) then ((macros.run "Modifier Stack" "Show_End_Result_Toggle") 
														Destr() MssgQ4 () )
														else if keyboard.ShiftPressed then (_Act_ConstrainFace() 
															Destr() MssgQ5 ())
														else if keyboard.controlPressed then (_Act_ConstrainEdg ()
															Destr() MssgQ6 ())
														else (_Act_Repeat_Last() Destr() )
														)
						(arg.Button.Right): (Destr())
														)
											)
						---***************
		on Btn1 mousedown arg do (
							case arg.Button of
											(
						(arg.Button.Left): 		(if keyboard.controlPressed then (_Act_1Ctr() Destr() )
														else if keyboard.shiftPressed  then (_Act_1Sh() Destr() )
														else ( _Act_1() Destr() )
															
														)
						(arg.Button.Middle): ()	
						(arg.Button.Right): (Destr())	
											)
										)
						---***************
		on Btn2 mousedown arg do (
							case arg.Button of
											(
						(arg.Button.Left): 		(if keyboard.controlPressed then (_Act_2Ctr() Destr() )
														else if keyboard.shiftPressed  then (_Act_2Sh() Destr() )
														else (_Act_2() Destr() )
														)
						(arg.Button.Middle): ()	
						(arg.Button.Right): (Destr())	
											)
										)
										
					---***************
		on Btn3 mousedown arg do (
							case arg.Button of
											(
						(arg.Button.Left): 		(if keyboard.controlPressed then (_Act_3Ctr() Destr() )
														else if keyboard.shiftPressed  then (_Act_3Sh() Destr() )
														else (_Act_3() Destr() )
															
														)
						(arg.Button.Middle):  	()	
						(arg.Button.Right): 		(Destr())	
											)
										) 	
							---***************
		on Btn4 mousedown arg do (
							case arg.Button of
											(
						(arg.Button.Left): 		(if keyboard.controlPressed then (_Act_4Ctr() Destr() )
														else if keyboard.shiftPressed  then (_Act_4Sh() Destr() )
														else (_Act_4() Destr() )
															
														)
						(arg.Button.Middle):  	()	
						(arg.Button.Right): 		(Destr())	
											)
										) 	
							---***************
		on BtnGr mousedown arg do (
							case arg.Button of
											(
						(arg.Button.Left): 		(if (keyboard.shiftPressed and keyboard.controlPressed) then (_Act_GroupShCtr() Destr() )
														else if keyboard.controlPressed then (_Act_GroupCtr() Destr() )
														else if keyboard.shiftPressed  then (_Act_GroupSh() Destr() )
														else if keyboard.AltPressed   then (_Act_GroupAlt() Destr() )
														else (_Act_Group() Destr() )
															
														)
						(arg.Button.Middle):  	(if (keyboard.shiftPressed and keyboard.controlPressed) then ((max delete) 
																													Destr() MssgQ1 ())
														)	
						(arg.Button.Right): 		(Destr())	
											)
										) 
							---***************
		on BtnSli mousedown arg do (
								case arg.Button of
												(
							(arg.Button.Left): 		(if (keyboard.shiftPressed and keyboard.controlPressed) then ()
															else if keyboard.controlPressed then (undo "MakePlanar" on try (_Act_Sli_LftCtr() Destr() ) Catch() )
															else if keyboard.shiftPressed  then ()
															else (_Act_Sli_Lft() Destr() )
																
															)
							(arg.Button.Middle):  	(if (keyboard.shiftPressed and keyboard.controlPressed) then ()
															else if keyboard.controlPressed then (undo "MakePlanar" on try (_Act_Sli_MdlCtr() Destr() ) Catch() )
															else (_Act_Sli_Mdl() Destr() ))	
							(arg.Button.Right): 		(if (keyboard.shiftPressed and keyboard.controlPressed) then ()
															else if keyboard.controlPressed then (undo "MakePlanar" on try (_Act_Sli_RghCtr() Destr() ) Catch() )
															else	(_Act_Sli_Rgh() Destr())
															)
												)
											) 						
							---***************
		on BtnMdf mousedown arg do (
								case arg.Button of
												(
							(arg.Button.Left): 		(if (keyboard.shiftPressed and keyboard.controlPressed) then ( )
															else if keyboard.controlPressed then ()
															else if keyboard.shiftPressed  then ()
															else (
																_Mdfr() Destr() )
																
															)
							(arg.Button.Middle):  	(if (keyboard.shiftPressed and keyboard.controlPressed) then ((macros.run "PolyTools" "ResetXForm")
																																				Destr() MssgQ7 ()
																																					)
															else if keyboard.controlPressed then (macros.run "Modifiers" "Symmetry")
															else (macros.run "Modifiers" "TurboSmoothMod"  )
																	Destr() 
															)	
							(arg.Button.Right): 		(if (keyboard.shiftPressed and keyboard.controlPressed) then ()
															else if keyboard.controlPressed then ( (macros.run "Modifier Stack" "Convert_to_Poly") 
																																		Destr() MssgQ8 ())
															else	((macros.run "Modifiers" "EditPolyMod")  
																Destr())
															)
												)
											)
										
	on Gr1 mousedown arg do (
								case arg.Button of
												(
							(arg.Button.Left): 		(if (keyboard.shiftPressed and keyboard.controlPressed) then ( )
															else if keyboard.controlPressed then (Destr())
															else if keyboard.shiftPressed  then (Destr())
															else (if (classOf Sl  == Editable_Poly) then ($.EditablePoly.ShrinkSelection () ) 
																else if (classOf Sl  == Edit_Poly) then($.modifiers[#Edit_Poly].ButtonOp #ShrinkSelection))
															
															)
							(arg.Button.Middle):  	(if (keyboard.shiftPressed and keyboard.controlPressed) then ()
															
															else if keyboard.controlPressed then ()
															else ()
																	Destr() 
															)	
							(arg.Button.Right): 		(if (keyboard.shiftPressed and keyboard.controlPressed) then ()
															else if keyboard.controlPressed then ( )
															else	(							Destr())
															)
												)
											)
											
	on Gr2 mousedown arg do (
								case arg.Button of
												(
							(arg.Button.Left): 		(if (keyboard.shiftPressed and keyboard.controlPressed) then ( )
															else if keyboard.controlPressed then (Destr())
															else if keyboard.shiftPressed  then (Destr())
															else (if (classOf Sl  == Editable_Poly) then ($.EditablePoly.GrowSelection () )
																		else if  (classOf Sl  == Edit_Poly) then ($.modifiers[#Edit_Poly].ButtonOp #GrowSelection))
																
															)
							(arg.Button.Middle):  	(if (keyboard.shiftPressed and keyboard.controlPressed) then ()
															
															else if keyboard.controlPressed then ()
															else ()
																	Destr() 
															)	
							(arg.Button.Right): 		(if (keyboard.shiftPressed and keyboard.controlPressed) then ()
															else if keyboard.controlPressed then ( )
															else	(							Destr())
															)
												)
											)
											
										

				on Lvl1 mousedown arg do (
								case arg.Button of
												(
							(arg.Button.Left): 		(if keyboard.controlPressed then ( if Cl_edit () and selection.count>0 then ($.EditablePoly.ConvertSelection  #CurrentLevel #Vertex)
																											macros.run "Modifier Stack" "SubObject_1"
																											Destr())
																else	 (max modify mode	
																	(macros.run "Modifier Stack" "SubObject_1")	
																Destr() )
																)
							(arg.Button.Middle):  	(max select
																	Destr() 
															)	
							(arg.Button.Right): 		(Destr()
															)
												)
											)
						
	
			on Lvl2 mousedown arg do (
								case arg.Button of
												(
							(arg.Button.Left): 		(if keyboard.controlPressed then ( if Cl_edit () and selection.count>0 then ($.EditablePoly.ConvertSelection  #CurrentLevel #Edge)
																											macros.run "Modifier Stack" "SubObject_2"
																											Destr())
																else	 (max modify mode	
																	(macros.run "Modifier Stack" "SubObject_2")	
																Destr() )
																)
							(arg.Button.Middle):  	(max move
																	Destr() 
															)	
							(arg.Button.Right): 		(							Destr()
															)
												)
											)
			on Lvl3 mousedown arg do (
								case arg.Button of
												(
							(arg.Button.Left): 		(if keyboard.controlPressed then ( if Cl_edit () and selection.count>0 then ($.EditablePoly.ConvertSelection  #CurrentLevel #Border)
																											macros.run "Modifier Stack" "SubObject_3"
																											Destr())
																else	 (max modify mode	
																	(macros.run "Modifier Stack" "SubObject_3")	
																Destr() )
																)
							(arg.Button.Middle):  	(if keyboard.controlPressed then (actionMan.executeAction 0 "59225")  -- Tools: Select and Manipulate
															else (max rotate)
								
																	Destr() 
															)	
							(arg.Button.Right): 		(							Destr()
															)
												)
											)
			on Lvl4 mousedown arg do (
								case arg.Button of
												(
							(arg.Button.Left): 		(if keyboard.controlPressed then ( if Cl_edit () and selection.count>0 then ($.EditablePoly.ConvertSelection  #CurrentLevel #Face)
																											macros.run "Modifier Stack" "SubObject_4"
																											Destr())
																else	 (max modify mode	
																	(macros.run "Modifier Stack" "SubObject_4")	
																Destr() )
																)
							(arg.Button.Middle):  	(max scale
																	Destr() 
															)	
							(arg.Button.Right): 		(							Destr()
															)
												)
											)
			on Lvl5 mousedown arg do (
								case arg.Button of
												(
							(arg.Button.Left): 		(if keyboard.controlPressed then ( if Cl_edit () and selection.count>0 then ($.EditablePoly.ConvertSelection  #CurrentLevel #Element)
																											macros.run "Modifier Stack" "SubObject_5"
																											Destr())
																else	 (max modify mode	
																	(macros.run "Modifier Stack" "SubObject_5")	
																Destr() )
																)
							(arg.Button.Middle):  	(actionMan.executeAction 0 "40211"  -- Edit: Normal Align 
																	Destr() 
															)	
							(arg.Button.Right): 		(							Destr()
															)
												)
											)
		----------********************	


			on BtnM keydown evnt do (
							if evnt.keycode == evnt.keycode.space do (Destr())
							if evnt.keycode == evnt.keycode.Escape do (Destr())
							
							if evnt.keycode == evnt.keycode.w do (actionMan.executeAction 0 "59235" -- Selection: Lasso Selection Region
																					Destr()) 
							if evnt.keycode == evnt.keycode.q do (actionMan.executeAction 0 "59232" -- Selection: Lasso Selection Region
																						Destr()) 
							if evnt.keycode == evnt.keycode.a do (max modify mode	
																					(subobjectLevel = 0)	
																						Destr())
							
							if evnt.keycode == evnt.keycode.x do (undo "ResetXform" on try (macros.run "PolyTools" "ResetXForm") catch()
																					Destr() MssgQ7 ())
							if evnt.keycode == evnt.keycode.e do (max delete 
																				Destr() MssgQ1 ()	)
															
							if evnt.keycode == evnt.keycode.Oem3 do (	(actionMan.executeAction 0 "40074") 
																									Destr() )  -- Snaps: Angle Snap Toggle
							if evnt.keycode == evnt.keycode.s do (undo "ConvrtEdit" on try (convertTo $ PolyMeshObject) catch() 
																						Destr() MssgQ8 ()
							if evnt.keycode == evnt.keycode.tab do (	(actionMan.executeAction 0 "40074") 
																									Destr() )	
								)
																						
(
							if selection.count == 0 and subobjectLevel == 0 or subobjectlevel == undefined then (_BColr)
							else if  numSubObjectLevels < 1  and subobjectlevel != 1 then (_BColr) -- big then Sl ----
							else if   numSubObjectLevels < 2  and subobjectlevel != 1 then (_FColr) -- small of lagre then Sl ---
							else if  subobjectlevel == 1 then (_SlColr)  -- Color Sl lvl
							else (_FColr)
									)


								
		if evnt.keycode == evnt.keycode.D1 do (if selection.count == 1 and subobjectLevel != 1  then (macros.run "Modifier Stack" "SubObject_1")
																else if subobjectLevel == 1 then (Max Create Mode); (Max Modify Mode)
																	) 	
							if evnt.keycode == evnt.keycode.D2 do (if selection.count == 1 and subobjectLevel != 2  then (macros.run "Modifier Stack" "SubObject_2")
																else if subobjectLevel == 2 then (Max Create Mode); (Max Modify Mode)
																				)	
							if evnt.keycode == evnt.keycode.D3 do (if selection.count == 1 and subobjectLevel != 3  then (macros.run "Modifier Stack" "SubObject_3")
																else if subobjectLevel == 3 then (Max Create Mode); (Max Modify Mode)
																								)
							if evnt.keycode == evnt.keycode.D4 do (if selection.count == 1 and subobjectLevel != 4  then (macros.run "Modifier Stack" "SubObject_4")
																else if subobjectLevel == 4 then (Max Create Mode); (Max Modify Mode)
																						)
							if evnt.keycode == evnt.keycode.D5 do (if selection.count == 1 and subobjectLevel != 5  then (macros.run "Modifier Stack" "SubObject_5")
																else if subobjectLevel == 5 then (Max Create Mode); (Max Modify Mode)
																			)
								
													)	
						
				on BtnHelpQ mousedown evnt do ( _HelpMsgQ()
													Destr() )
 

						
			on t tick do (	Destr()	)	
						

									
									

									
	)
		

	
	createdialog _SvDialogF style:#()  bgcolor: (color 2 15 30) 
)
